import SOMA.agent.*;
import SOMA.naming.*;
import SOMA.resourceManagement.*;
import SOMA.network.connection.*;
import SOMA.Environment;

import java.io.PrintStream;
import java.util.*;


/** Action Monitoring Agent
  * Questo agente non serve a raccogliere informazioni, bens sostituisce 
	* l'invio dello stesso comando (primo argomento) su vari place (argomenti successivi)
	*/
public class ActionMA extends Agent{
	
	Command currentCommand;
  boolean[] actionOK; 
  PlaceID initPlace = null, places[] = null;
  HashSet notReacheablePlaces = new HashSet();
  int index = -1;

  // si potrebbero aggiungere controlli, magari in assenza di place indicati 
  // esplicitamente prendere come elenco di default quello di tutti i place del dominio
  public void putArgument( Object obj){
  
    Object[] args = (Object[])obj;
  
    currentCommand=(Command)args[0];
    actionOK = new boolean[args.length-1];
    for (int i=0; i<args.length-1; i++) actionOK[i]=false;
    // inizializzo tutti gli stati di ritorno a false, saranno poi posti a true 
    // se tutto va bene
    places = new PlaceID[args.length-1];

    for (int i=1; i<places.length; i++){
     try{
       places[i] = new PlaceID((String)args[i]);
     }
     catch(NameException ex){
       try{
         places[i] = new PlaceID("DummyDomain DummyPlace");
       }
       catch(NameException e){
         e.printStackTrace();
       }
     }
  }
}


  public void run(){
    
    PrintStream out = agentSystem.getOut();  
    initPlace = agentSystem.getPlaceID();

    out.println("ActionMA -> visiter i seguenti places:");
    for (int i=0; i<places.length; i++)
      out.println((i+1) + ") " + places[i]);

    monitoringTour();
  }


  public void monitoringTour(){
    
    PrintStream out = agentSystem.getOut();
    index++;

    if (index<places.length){
     try{
       go(places[index], "getInfo"); 
     }
     catch( CantGoException ex){
      notReacheablePlaces.add(places[index]);
      ex.printStackTrace(out);
      out.println("AgentMA -> il place " + places[index]
              + " non  raggiungibile; vado al place successivo");
      monitoringTour();
     }
    }
    else{
      try{
        out.println("AgentMA -> tour di monitoraggio terminato, torno al place di partenza: " + initPlace);
        go(initPlace, "deliverInfo");
      }
      catch( CantGoException ex){
        ex.printStackTrace(out);
        out.println("AgentMA -> ritorno al place di partenza fallito");
      }
    }
  }


  public void performAction() {
    
    currentCommand.run();
    actionOK[index]=true; 
    // suppongo che se il flusso d'esecuzione arriva qui le cose siano andate bene, 
    // non  una gran garanzia, bisognerebbe definire uno stato di ritorno del metodo run...
    monitoringTour();

  }



  public void deliverInfo(){
   
   PrintStream out = agentSystem.getOut();  
   out.println("ActionMA -> informazioni sull'esecuzione dl comando nei vari place:");
   for (int i=0; i<places.length; i++){
      	out.println("Place:" + places[i]);
      	out.println("Stato esecuzione comando:" + actionOK[i]);
   }

  }
}
 