import SOMA.agent.*;
import SOMA.naming.*;
import SOMA.resourceManagement.*;

import java.io.PrintStream;
import java.util.*;


/** Band Width Monitoring Agent
  * Questo agente raccoglie l'occupazione di banda complessiva e il numero di agenti 
  * su ciascuno dei place passati come argomenti. 
  */
public class BandWidthMA extends Agent{
  
  HashSet placesBandInfo = new HashSet();
 
  
  PlaceID initPlace = null, places[] = null;
  HashSet notReacheablePlaces = new HashSet();
  int index = -1;


  public void putArgument( Object obj){
   
   Object[] args = (Object[])obj;
  
   places = new PlaceID[args.length];

   for (int i=0; i<places.length; i++){
    try{
      places[i] = new PlaceID((String)args[i]);
    }
    catch(NameException ex){
     try{
       places[i] = new PlaceID("DummyDomain DummyPlace");
     }
     catch(NameException e){
       e.printStackTrace();
     }
    }
   }
  }



  public void run(){
    
    PrintStream out = agentSystem.getOut();  
    initPlace = agentSystem.getPlaceID();

    out.println("BandWidthMA -> visiter i seguenti places:");
    for (int i=0; i<places.length; i++)
      out.println((i+1) + ") " + places[i]);

    monitoringTour();
  }



  public void monitoringTour(){
    
    PrintStream out = agentSystem.getOut();
    index++;

    if (index<places.length){
     try{
       go(places[index], "getInfo"); 
     }
     catch( CantGoException ex){
      notReacheablePlaces.add(places[index]);
      ex.printStackTrace(out);
      out.println("BandWidthMA -> il place " + places[index]
              + " non  raggiungibile; vado al place successivo");
      monitoringTour();
     }
    }
    else{
      try{
        out.println("BandWidthMA -> tour di monitoraggio terminato, torno al place di partenza: " + initPlace);
        go(initPlace, "deliverInfo");
      }
      catch( CantGoException ex){
        ex.printStackTrace(out);
        out.println("BandWidthMA -> ritorno al place di partenza fallito");
      }
    }
  }



  public void getInfo() {
    
    PlaceBandInfo temp = new PlaceBandInfo(agentSystem.getPlaceID());
    temp.agentsNum = agentSystem.agentsNumber();
	  // recupero i consumi di tutti gli agenti nell'ultimo intervallo di polling
	  AgentInfo[] info = (agentSystem.getEnvironment()).placeResourceManager.getAgentDiffConsumptions();
  
  // scandisco i consumi e sommo quelli relativi all'occupazione di banda
  if (info!=null)
  for (int i=0;i<info.length; i++){
   temp.bandUsage+=info[i].tcp_in;
	 temp.bandUsage+=info[i].tcp_out;
	 temp.bandUsage+=info[i].udp_in;
	 temp.bandUsage+=info[i].udp_out;
  }
  
  // aggiungo le info relative a questo place alla lista
  placesBandInfo.add(temp);
  
  monitoringTour();

  }



  public void deliverInfo(){
   
   PrintStream out = agentSystem.getOut();
   PlaceBandInfo info;  
   out.println("MonitoringAgent -> informazioni sull'occupazione di banda:");
   Iterator iter = placesBandInfo.iterator();
   for (; iter.hasNext();){
   	info = (PlaceBandInfo)iter.next();
    out.println("Place: "+ info.placeID);
	  out.println("Numero di agenti: "+ info.agentsNum);
	  out.println("Occupazione di banda: "+ info.bandUsage);
	  out.println("--------------------------------------");
   }
	
   /*(agentSystem.getEnvironment()).domainResourceManager.placesBandInfo = placesBandInfo;*/
   
  }

 
}