import java.net.*;
import java.io.*;
import java.util.*;

import MDR.user.*;
import MDR.datamodel.*;
import MDR.language.*;
import MDR.utils.*;

import MDR.gui.*;
import MDR.gui.mdrclientgui.*;
import MDR.client.*;

import java.awt.*;
import java.awt.event.*;
//import agentsystem.*;

public class MDRClient implements ActionListener,ItemListener {

    semaforo exit;
    String userName;
    String userPassword;
    String hostName;
    int hostPort;
    LoginDialog login;
    Host2Dialog host;
    ClientGUI gui;
    Socket sock;
    ArrayList models;
    DataModel model;
    ArrayList subscribedQueries;

    ArrayList addedQueries;
    ArrayList removedQueries;

    ObjectOutputStream ostream;
    ObjectInputStream istream;

    long interval=0;

    boolean updated=false;

    public MDRClient() {}
    
    public static void main(String[] args) {
        MDRClient client=new MDRClient();
        client.run();
    }

    public void run() {
        addedQueries=new ArrayList();
        removedQueries=new ArrayList();
        
        exit=new semaforo();
        host=new Host2Dialog(this);
        host.show();
        exit.unset();

        gui=new ClientGUI(this);
        gui.show();
        
        gui.message("Mi sto connettendo al server...");
        try {
            sock=new Socket(InetAddress.getByName(hostName),hostPort);
            OutputStream os=sock.getOutputStream();
            ostream=new ObjectOutputStream(os);
        } catch(IOException e) {
            gui.error("Impossibile stabilire una connessione col server");
            quit();
            System.exit(1);
        }
        gui.message("Connessione effettuata");

        exit=new semaforo();
        login=new LoginDialog(this);
        login.show();
        exit.unset();
        try {

	    gui.message("Invio dati di autenticazione");
            ostream.writeObject(userName);
            ostream.writeObject(userPassword);
            ostream.flush();
            InputStream is=sock.getInputStream();
            istream=new ObjectInputStream(is);
            String resultString=(String)istream.readObject();
            if(resultString.equals("Ok"))
                gui.message("Autenticazione accettata");
            else {
                gui.error("L'utente non e' autorizzato ad utilizzare il sistema");
                quit();
                System.exit(2);
            }
            gui.message("Richiedo la lista dei modelli");
            ostream.writeObject(new UserCommand("getModels",null));
            ostream.flush();
            models=(ArrayList)istream.readObject();
            models.add(0," ");
            gui.setModels(models);
            gui.message("Lista ottenuta, scegli un modello");
            exit=new semaforo();
            exit.unset();
            ostream.writeObject(new UserCommand("quit",null));
            ostream.flush();
            quit();
            /*LanguageCommand command=new LanguageCommand();
            command.addToTarget(new Variable("f","Titolo"));
            command.addToTarget(new Variable("f","Genere"));
            command.addToTarget(new Variable("f","Durata"));
            command.addToFrom("Film","f");*/
            //ostream.writeObject(new UserCommand("query",command));
            /*Object result=istream.readObject();
            if(result instanceof Exception)
                System.out.println("Errore: "+((Exception)result).getMessage());
            if(result instanceof DataModelInstance)
            System.out.println("Risultato:\n"+result);*/
            /*ostream.writeObject(new UserCommand("updateprofile",list));
            if(queries.size()==0)
                ostream.writeObject(new UserCommand("subscribe",new Object[] {command,new Long(60)}));
            for(int count=0;count<list.size();count++) {
                ostream.writeObject(new UserCommand("getresult",(Ticket)list.get(count)));
                QueryState result=(QueryState)istream.readObject();
                if(result.isError())
                    System.out.println("Error: "+result.getError());
                else
                    System.out.println("Result:\n"+result.getResult());
            }
            ostream.writeObject(new UserCommand("quit",null));
            System.out.println("Fine");
            istream.close();
            ostream.close();

            sock.close();*/
        } catch(IOException e) { e.printStackTrace(); }
        catch(ClassNotFoundException e) { e.printStackTrace(); }

    }

    /**
     * Cattura e gestisce gli eventi dell'interfaccia utente (pressione di bottoni e doppi click sulla lista di risorse).
     * @param evt evento catturato
     */
    public synchronized void actionPerformed(ActionEvent evt) {
        if(evt.getActionCommand().equals("Avanti>>")) {
            userName=login.getName();
            userPassword=login.getPassword();
            login.quit();
            exit.set();
        }
        if(evt.getActionCommand().equals("Ok")) {
            hostName=host.getHost();
            hostPort=host.getPort();
            host.quit();
            exit.set();
        }
        if(evt.getActionCommand().equals("Esci")) {
            exit.set();
        }
        if(evt.getActionCommand().equals("Invia Interrogazione")) {
            try {
                LanguageCommand query=getQuery(3);
                System.out.println("Query: "+query);
                doQuery(query);
            } catch(MDR.client.ParseException e) {
                gui.message("Errore: "+e.getMessage());
            }
        }
        if(evt.getActionCommand().equals("Aggiungi")) {
            try {
                LanguageCommand query=getQuery(4);
                if(query!=null) {
                    if(subscribeQuery(query,interval))
                        gui.addQuery(query.toString(),interval);
                    System.out.println("Query: "+query);
                    System.out.println("Interval: "+interval);
                }
            } catch(MDR.client.ParseException e) {
                gui.message("Errore: "+e.getMessage());
            }
        }
        if(evt.getActionCommand().equals("Aggiorna")) {
            ArrayList indexes=gui.getUpdatables();
            ArrayList queries=new ArrayList();
            for(int count=0;count<indexes.size();count++) {
                int pos=((Integer)indexes.get(count)).intValue();
                QueryStateCompact state=(QueryStateCompact)subscribedQueries.get(pos);
                queries.add(state.getTicket());
            }
            try {
                ostream.writeObject(new UserCommand("updateprofile",queries));
                updated=true;
                gui.message("");
                gui.activate();
            } catch(IOException e) {
                gui.error("Errore di comunicazione col server");
            }
        }
        if(evt.getActionCommand().equals("Risultato")) {
            try {
                int index=gui.getSelectedIndex();
                QueryStateCompact state=(QueryStateCompact)subscribedQueries.get(index);
                ostream.writeObject(new UserCommand("getresult",state.getTicket()));
                QueryState result=(QueryState)istream.readObject();
                if(result.isError())
                    gui.error(result.getError());
                else {
                    ResultBrowser dialog=new ResultBrowser(gui,true);
                    dialog.setResult((DataModelInstance)result.getResult());
                    dialog.show();
                    //System.out.println("Result:\n"+result.getResult());
                }
            } catch(IOException e) {
                gui.error("Errore nel prelievo del risultato");
            } catch(ClassNotFoundException e) {
                gui.error("Errore nel prelievo del risultato");
            }
        }
    }

    boolean subscribeQuery(LanguageCommand query,long interval) {
        try {
            ostream.writeObject(new UserCommand("subscribe",new Object[] {query,new Long(interval)}));
            return true;
        } catch(IOException e) {
            gui.error("Errore di comunicazione con il server");
            return false;
        }
    }
        
    void doQuery(LanguageCommand query) {
        try {
			System.out.println(" 1  ");
            ostream.writeObject(new UserCommand("query",query));
			System.out.println(" 1  ");
            Object result=istream.readObject();
            if(result instanceof Exception)
    	        gui.error("Errore: "+((Exception)result).getMessage());
			System.out.println(" 1  ");
            if(result instanceof DataModelInstance) {
			System.out.println(" 1  ");
                ResultBrowser dialog=new ResultBrowser(gui,true);
                dialog.setResult((DataModelInstance)result);
                dialog.show();
            }
        } catch(IOException e) {
            gui.error("Errore di comunicazione col server (IOException)");
        } catch(ClassNotFoundException e) {
            gui.error("Errore di comunicazione col server (ClassNotFoundException)");
        }
    }
    
    LanguageCommand getQuery(int maxlevel) throws MDR.client.ParseException {
        MDRDialog[] dialogs=new MDRDialog[maxlevel];
        int currentDialog=1;
        boolean aborted=false;
        ClassSelect dialog1=new ClassSelect(gui,true);
        dialogs[0]=dialog1;
        ArrayList classes=new ArrayList();
        Iterator iter=model.getComponents();
        while(iter.hasNext()) {
            ModelComponent comp=(ModelComponent)iter.next();
            classes.add(comp.getName());
        }
        dialog1.setClasses(classes);
        AttributesSelect dialog2=new AttributesSelect(gui,true);
        dialogs[1]=dialog2;
        WhereDialog dialog3=new WhereDialog(gui,true);
        dialogs[2]=dialog3;
        if(maxlevel==4) {
            IntervalDialog dialog4=new IntervalDialog(gui,true);
            dialogs[3]=dialog4;
        }
        while(currentDialog<=maxlevel && !aborted) {
            dialogs[currentDialog-1].show();
            if(dialogs[currentDialog-1].isOk()) {
                currentDialog++;
                switch(currentDialog) {
                case 2: {
                    ClassSelect prevDialog=(ClassSelect)dialogs[0];
                    AttributesSelect dialog=(AttributesSelect)dialogs[1];
                    ModelComponent comp=model.getComponent(prevDialog.getSelectedClass());
                    dialog.setStartingClass(comp);
                    break;
                }
                case 3: {
                    ClassSelect prevDialog=(ClassSelect)dialogs[0];
                    WhereDialog dialog=(WhereDialog)dialogs[2];
                    ModelComponent comp=model.getComponent(prevDialog.getSelectedClass());
                    dialog.setStartingClass(comp);
                    break;
                }
                case 5: {
                    if(maxlevel==4) {
                        IntervalDialog dialog=(IntervalDialog)dialogs[3];
                        interval=dialog.getInterval();
                    }
                    break;
                }
                }
            } else if(dialogs[currentDialog-1].isBack()) {
                currentDialog--;
            } else
                aborted=true;
        }
        if(aborted)
            return null;
        else {
            return buildQuery(dialog1.getSelectedClass(),dialog2.getSelectedAttributes(),dialog3.getWhere());
        }
    }

    LanguageCommand buildQuery(String className,ArrayList attrNames,String where) throws MDR.client.ParseException {
        LanguageCommand query=new LanguageCommand();
        query.addToFrom(className,className,true);
        if(!where.equals("")) {
            WhereParser parser=new WhereParser(where);
            LangExpr whereClause=parser.parse();
            query.setWhere(whereClause);
            attrNames.addAll(parser.getAttributes());
        }
        ArrayList newAttrNames=analyzeAttributes(attrNames);
        for(int count=0;count<newAttrNames.size();count++) {
            String attr=(String)newAttrNames.get(count);
            Variable var=new Variable(attr.substring(0,attr.indexOf('.')),attr.substring(attr.indexOf('.')+1));
            query.addToTarget(var);
        }
        return query;
    }

    ArrayList analyzeAttributes(ArrayList attribs) {
        HashMap classes=new HashMap();
        ArrayList alreadyPut=new ArrayList();
        ArrayList copy=(ArrayList)attribs.clone();
        Collections.sort(copy,new VariableComparator());
        ArrayList toReturn=new ArrayList();
        for(int count=0;count<copy.size();count++) {
            String attrName=(String)copy.get(count);
            String firstPart=attrName.substring(0,attrName.lastIndexOf('.'));
            String lastPart=attrName.substring(attrName.lastIndexOf('.')+1);
            if(!(classes.containsKey(firstPart.toUpperCase()))) {
                ModelComponent comp=getComponent(attrName);
                classes.put(firstPart.toUpperCase(),comp);
                Iterator iter=comp.getAllIdentifiers();
                while(iter.hasNext()) {
                    String idAttr=(String)iter.next();
                    toReturn.add(firstPart.toUpperCase()+"."+idAttr.toUpperCase());
                }
            }
            if(!(toReturn.contains(attrName.toUpperCase())))
                toReturn.add(attrName.toUpperCase());
        }
        return toReturn;
    }

    public ModelComponent getComponent(String attrName) {
        int currentPos=attrName.indexOf('.');
        String className=attrName.substring(0,currentPos);
        ModelComponent currentComp=model.getComponent(className);
        attrName=attrName.substring(currentPos+1);
        while(attrName.indexOf('.')!=-1) {
            currentPos=attrName.indexOf('.');
            String currentAttrName=attrName.substring(0,currentPos);
            LinkAttribute currentAttr=(LinkAttribute)currentComp.getAttribute(currentAttrName);
            currentComp=currentAttr.getLink();
            attrName=attrName.substring(0,currentPos);
        }
        return currentComp;
    }
    
    public synchronized void itemStateChanged(ItemEvent evt) {
        if(gui.isModel(evt.getItemSelectable())) {
            String modelName=gui.getModel();
            if(!(modelName.equals(" "))) {
		System.out.println("1");
                try {
                    ostream.writeObject(new UserCommand("changeModel",gui.getModel()));
		System.out.println("1");
                    ostream.flush();
                    model=(DataModel)istream.readObject();
		System.out.println("1");
                    subscribedQueries=(ArrayList)istream.readObject();
		System.out.println("1");
                } catch(IOException e) {
		System.out.println("E");
                    gui.message("Non riesco a cambiare il modello");
                    return;
                } catch(ClassNotFoundException e) {
		System.out.println("E");
                    gui.message("Non riesco a cambiare il modello");
                    return;
                }
		System.out.println("1");
                for(int count=0;count<subscribedQueries.size();count++) {
		System.out.println("A");
                    QueryStateCompact state=(QueryStateCompact)subscribedQueries.get(count);
                    gui.addSubscribedQuery(state.isUpdated(),false,state.getQuery());
                }
		System.out.println("1");
                if(subscribedQueries.size()>0)
                    gui.message("Seleziona le query da aggiornare e premi il bottone Aggiorna");
                else {
                    try {
		System.out.println("1");
                        ostream.writeObject(new UserCommand("updateprofile",new ArrayList()));
                        updated=true;
		System.out.println("1");
                        gui.message("");
                        gui.activate();
                    } catch(IOException e) {
                        gui.error("Errore di comunicazione col server (IOException in itemStateChanged )");
                    }
                }
                
            }
        } else if(gui.isQuery(evt.getItemSelectable())) {
            if(evt.getStateChange()==evt.SELECTED && updated) {
                String item=gui.getSelectedQuery();
                int index=gui.getSelectedIndex();

                if(item.startsWith("*")) {
                    gui.activeResult();
                }

                gui.activeRemove();
            }
            
        }
    }

    public void quit() {
        try {
            if(istream!=null)
                istream.close();
            if(ostream!=null)
                ostream.close();
            if(sock!=null)
                sock.close();
        } catch(IOException e) {}
        gui.quit();
        System.exit(0);
    }
}