package MobileMonitoring;

import StaticMonitoring.Settings;
import StaticMonitoring.InfoDomain;
import MonitorConfig.IpAddress;
import SOMA.agent.*;
import SOMA.naming.*;
import SOMA.utility.*;
import com.adventnet.snmp.snmp2.*;
import java.io.*;
import java.util.*;
import java.net.*;


public class DomainInfoMA extends SnmpV3MobileManager
{
	String[] reqOIDs;
	InfoDomain result;
	transient IpAddress iplocal;

	/**qui si recuperano le singole informazioni a partire dall'oggetto passato
    //in input.
    //o e' un oggetto della classe InfoAtomicSnmpOp
    */
    public void putArgument(Object o)
    {
        InfoAtomicSnmpOp Info = (InfoAtomicSnmpOp) o;
        super.putArgument(Info);
        reqOIDs = Info.getIDs();
        result = new InfoDomain(reqOIDs.length);
        job_result = new Vector(1);
    }

	/**questo  il metodo di partenza, eseguito all'attivazione dell'agente:
    //qui si avvia il cronometro che conter il tempo necessario al completamento
    //dell'operazione, si definir la prima tappa del "viaggio" e si inizializzer
    //il campo home che dovr poi essere utilizzato per il ritorno al Place
    //di partenza
    */
    public void run()
    {
        super.run();
    }

    /**metodo di passaggio ad una tappa successiva,  qui che si controlla se il viaggio
    // finito, in tal caso si torna al Place di partenza
    */
    public void goNext()
    {
        super.goNext();
    }

    /**metodo di preparazione dell'ambiente locale ai fini dell'adempimento
    //del compito: creazione thread di gestione delle sessioni Snmp, creazione
    //di una sessione Snmp per l'interazione con l'Agente Snmp presente localmente
    //eventuale (caso V3) deserializzazione della configurazione del motore Snmp da file
    //non posso sfruttare quello della superclasse, perche' qui non utilizzo job_result[]
    */
    public void prepareLocalJob()
    {
        PrintStream out = agentSystem.getOut();
        String location = agentSystem.getPlaceID().toString();
		Settings sets = null;
		
        if ( !(location.equals(targets[current].toString())) )
        {
            trace_err(out,getHeader()+" Wrong Target. Right is: "+targets[current]);
            result_code[current++] = false;
            nexthop = targets[current];
            goNext();
        }
        else
        {
            int version = snmpVs[current];
            int port = snmpPorts[current];

			try{iplocal = new IpAddress(InetAddress.getLocalHost(),port);}
			catch(Exception e){ iplocal = new IpAddress("127.0.0.1",port);}

            String params[] = new String[Settings.NMAXOPTIONS];
            params[Settings.SECNAME] = securityNames[current];
            //setto i parametri "remoti": indirizzo,porta,versione dell'agente Snmp
            String host = "127.0.0.1";
            params[Settings.PORT] = Integer.toString(port);

            if (version == SnmpAPI.SNMP_VERSION_1)
            	params[Settings.VERSION] = "v1";
            else if (version == SnmpAPI.SNMP_VERSION_2C)
            	params[Settings.VERSION] = "v2";
            else
            	params[Settings.VERSION] = "v3";

            api = new SnmpAPI();
            api.start();
            SnmpSession session = new SnmpSession(api);
            //setto i parametri locali: indirizzo (localhost) e porta (la prima libera assegnata dal sistema)
            //da cui inviare le richieste all'agente Snmp.. in realta' e' gia' cosi' il default
            //String[] addrs = new String[1];
            //addrs[0] = "127.0.0.1":
            //session.setLocalAddresses(addrs);
            //session.setLocalPort(0);
            try {session.open();}
            catch(SnmpException ex) {trace_err(out,getHeader()+" Error opening the session");}

            //se si tratta di una richiesta V3 deserializzo poi eseguo i settaggi sulla sessione
            //tramite Settings
            if (version == SnmpAPI.SNMP_VERSION_3)
            {
                api.setSerializeFileName(serFile.getAbsolutePath());
                try
                {
                    if (api.deSerialize() == false)
                        trace_err(out,getHeader()+" Deserialization Problem Occurring");
                    result_code[current] = false;
                    if (++current != Ntargets)
	                    nexthop = targets[current];
                    goNext();
                }

                catch(SnmpException ex) { result_code[current] = false;
                    if (++current != Ntargets)
	                    nexthop = targets[current];
                    goNext();}
                sets = new Settings(session,host,params,true,debug,out);
            }
            //altrimenti effettuo subito i settaggi
            else
                sets = new Settings(session,host,params,false,debug,out);

            doLocalJob(session);
        }
    }

    public void doLocalJob(Settings sets,SnmpSession session)
    {
    	SnmpPDU answer = snmpOp(sets,session,reqOIDs);
    	if (check(answer) == false)
    	{
    		if (++current != Ntargets)
	    		nexthop = targets[current];
    		goNext();
    	}
    	Vector varbinds = answer.getVariableBindings();
    	SnmpVar[] localres = new SnmpVar[varbinds.size()];
    	int j=0;
    	for(Enumeration e = varbinds.elements(); e.hasMoreElements(); j++)
    	{
    		localres[j] = ((SnmpVarBind)e.nextElement()).getVariable();
    		//aggiorno il massimo
    		result.setCurMinMax(localres[j],j,">",iplocal);
    		//aggiorno il minimo
    		result.setCurMinMax(localres[j],j,"<",iplocal);
    		//aggiorno la somma
    		result.setCurSum(localres[j],j);
    	}

        session.close();
        api.close();

    	if (++current != Ntargets)
        	nexthop = targets[current];
        goNext();
    }

	  //verifica se la PDU ottenuta in risposta contiene errori o  null
    boolean check(SnmpPDU pdu)
    {
        PrintStream out = agentSystem.getOut();
        //verifico se la pdu e' nulla (time out)
        if (pdu == null)
        {
            trace_err(out,getHeader()+" NULL PDU in response");
            return false;
        }

        //verifico se la pdu contiene errori
        if (pdu.getErrstat() > 0)
        {
            trace_err(out,getHeader()+" Error occurred in PDU "+pdu.getError());
			pdu.fix();
            return false;
        }

        return true;
    }


     SnmpPDU snmpOp(Settings sets,SnmpSession session,String OIDs[])
     {
        PrintStream out = agentSystem.getOut();
        //creo una nuova PDU che dovro' poi spedire
        SnmpPDU pdu = new SnmpPDU();
        //setto il tipo di operazione nella pdu
        pdu.setCommand(SnmpAPI.GET_REQ_MSG);
        //introduco tutti gli OID richiesti nella PDU
        for (int j=0; j < OIDs.length; j++)
        {
            SnmpOID oid = new SnmpOID(OIDs[j]);
            if (oid.toValue() == null)
            {
                trace_err(out,getHeader()+" Invalid OID argument: "+OIDs[j]);
                return null;
            }
            else pdu.addNull(oid);
        }
		pdu.setUserName(sets.userName.getBytes());
		if (session.getVersion() == SnmpAPI.SNMP_VERSION_3)
		{
			if (sets.config == false)
			USMUtils.init_v3_params(sets.userName,sets.authProto,sets.authPwd,sets.privPwd,session.getPeername(),session.getRemotePort(),session);
			pdu.setContextName(sets.contextName.getBytes());
			pdu.setContextID(sets.contextID.getBytes());
		}
		
        try  { pdu = session.syncSend(pdu); }
        catch (SnmpException e)
        {
            trace_err(out,getHeader()+" Sending PDU"+e.getMessage());
            return null;
        }

        return(pdu);
   }

    //metodo di ritorno al Place di partenza
    public void goHome()
    {
    	//calcolo del valore medio dopo aver reperito tutte le info.
    	result.setAve();
        super.goHome();
    }

    //metodo che racchiude le azioni da svolgere una volta tornati al Place di partenza
    public Message EndofPlan()
    {
       	job_result.add(0,result);
        return(super.EndofPlan());
    }

    //metodo di visualizazione dei risultati su un particolare PrintStream
    void ShowJob(PrintStream o)
    {
        o.println("Data retrieved from "+getID().toString());
        for (int j=0; j<reqOIDs.length; j++)
        {
            o.println(reqOIDs);
            o.println("Max Value: "+result.getMax(j)+" on Snmp Agents: "+result.getMaxLocations(j));
            o.println("Min Value: "+result.getMax(j)+" on Snmp Agents: "+result.getMinLocations(j));
            o.println("Average  : "+result.getAve(j));
        }
    }

}



