package MobileMonitoring;

import StaticMonitoring.Settings;
import SOMA.agent.*;
import SOMA.naming.*;
import SOMA.utility.*;
import com.adventnet.snmp.snmp2.*;
import java.io.*;
import java.util.*;
import java.net.*;

public class HealthMA extends SnmpAtomicOpMA
{

	String HF = null;
	String rowID = null;
	
    /**qui si recuperano le singole informazioni a partire dall'oggetto passato
    //in input.
    //o e' un oggetto della classe InfoAtomicSnmpOp
    */
    public void putArgument(Object o)
    {
        InfoHF Info = (InfoHF) o;
        HF = Info.getHF();
        rowID = Info.getrowID();
        
        //se si tratta di una tabella devo introdurre come primo elemento dell'array di OID
        //quello corrispondente al nome di riga
        if (rowID != null)
        {
        	String[] oids = new String[reqOIDs.length];
        	for (int i=0; i<reqOIDs.length; i++)
        		oids[i] = reqOIDs[i];
        	reqOIDs = new String[oids.length+1]; 
        	reqOIDs[0] = rowID;
        	for (int k=1; k<reqOIDs.length; k++)
        		reqOIDs[k] = oids[k-1];
        }
        super.putArgument(Info.sub);
        argsop = null;
    }

    //qui sono racchiuse le operazioni necessarie all'adempimento del compito
    //specifico di questo Agente Mobile
    public void doLocalJob(Settings sets,SnmpSession session)
    {
        PrintStream out = agentSystem.getOut();
        if (rowID != null)
        	job_result.add(current,snmpTableHF(sets,session));
        else
        	job_result.add(current,snmpHF(sets,session));

        result_code[current] = true;
        session.close();
        api.close();
        if (++current != Ntargets)
        	nexthop = targets[current];
        goNext();
    }

 /*esegue la valutazione di una health function specificata dall'utente a partire dai parametri specificati in
   //input: ciascuno occupa una precisa posizione all'interno di args[]
   //host e' l'indirizzo presso cui si trova l'agente Snmp da interrogare
   //args e' il vettore dei parametri: la posizione di ogni parametro e' definita dalle variabili
   //static della classe Settings
   //HF e' l'health function sotto forma di stringa espressa in funzione di variabili Snmp in forma numerica e/o simbolica
   //from_config stabilisce se i parametri sono tutti contenuti in args (false) o se devono anche essere recuperati
   //dalla configurazione del motore Snmp locale (true)
   //restituisce l'Object (Integer/Long) di risposta o null se ci sono stati problemi
   */
  	public Object snmpHF(Settings sets,SnmpSession session)
  	{
        PrintStream out = agentSystem.getOut();
        op_snmp = SnmpAPI.GET_REQ_MSG;
        
		//N.B.!! prevedo che la stringa sia gia' fornita con OID tutti numerici
		//perche' l'agente non avrebbe modo di convertirli in numerici

  		//richiedo il reperimento del valore associato alle variabili tramite una snmpGet normale
  		SnmpPDU pdu = snmpOp(sets,session,reqOIDs,op_snmp,argsop);
  		//ora recupero dalla pdu di risposta il valore di ogni var e lo associo all'oid corrispondente in una hashtable cosi' da
  		//poterli poi recuperare  facilmente al momento della valutazione
  		Hashtable values = new Hashtable();
  		int j =0;
  		for (Enumeration e = pdu.getVariableBindings().elements(); e.hasMoreElements(); )
  		{
  			SnmpVarBind varb = (SnmpVarBind) e.nextElement();
  			Object val = varb.getVariable().toValue();
  			try
  			{  values.put(reqOIDs[j++],val);  }
  			catch (NullPointerException ex) { trace_err(out,"Value of variable "+reqOIDs[j]+" not available");  return null;}
  		}

  		//chiamo la funzione di valutazione della HF passando come primo operando null, come numero di parentesi aperte 0 e
  		//trasmettendo la conoscenza delle associazioni variabile-valore
  		return (evalHF(new ret(HF), values).ris);
  	}
  	
	/**funzione da utilizzare nel caso si abbia a che fare con OID appartenenti a una tabella
	/* si recupera anche il nome di ogni riga per poter distinguere i risultati 
	/* la Hashtable di ritorno contiene un insieme di associazioni (nome riga ---> valore HF per la riga)
	*/
	public Hashtable snmpTableHF(Settings sets,SnmpSession session)
	{
        PrintStream out = agentSystem.getOut();
        op_snmp = SnmpAPI.GETNEXT_REQ_MSG;
        
        //memorizzo in una variabile temporanea gli OID perche' poi nel corso del calcolo verranno cambiati
        //i reqOIDs invece devono rimanere sempre gli stessi per essere utilizzati anche sugli altri nodi
		String[] tempOIDs = new String[reqOIDs.length]; 
		for (int k=0; k<reqOIDs.length;k++)
			tempOIDs[k] = reqOIDs[k];
		Hashtable rowsHF = new Hashtable(); 
		boolean next = true;
		boolean first = true;
		
		SnmpPDU pdu = new SnmpPDU();
		//entro in un ciclo di recupero dei valori delle variabili e di calcolo della HF
		//che dura fino a che quello che reperisco fa sempre parte della stessa tabella
		while (next)
		{
  			pdu = snmpOp(sets,session,tempOIDs,op_snmp,argsop);
  			
  			//proseguo solo se quello che ho ricevuto appartiene alla tabella
  			next = isInTable(pdu);
  			
  			if (next)
  			{
  				Object whichrow = null;  			
  				//ora recupero dalla pdu di risposta il valore di ogni var e lo associo all'oid corrispondente in una hashtable cosi' da
  				//poterli poi recuperare  facilmente al momento della valutazione
  				Hashtable values = new Hashtable();
  				int j =0;
  				for (Enumeration e = pdu.getVariableBindings().elements(); e.hasMoreElements(); )
  				{
  					SnmpVarBind varb = (SnmpVarBind) e.nextElement();
  				
  					//se e' la prima variabile si tratta del nome della riga
  					if (j == 0)
  					{
  						whichrow = varb.getVariable().toValue();
  						j = 0;
  					}
  					else //valori delle var da utilizzare nel calcolo della HF
  					{
  						Object val = varb.getVariable().toValue();
  						try
  						{  values.put(reqOIDs[j++],val);  }
  						catch (NullPointerException ex) { trace_err(out,"Value of variable "+reqOIDs[j]+" not available");  return null;}
  					}
  				}

  				//chiamo la funzione di valutazione della HF passando come primo operando null, come numero di parentesi aperte 0 e
  				//trasmettendo la conoscenza delle associazioni variabile-valore
  				//inserisco poi nella hashtable l'associazione nome di riga corrente --> valore HF
  				rowsHF.put(whichrow,evalHF(new ret(HF), values).ris);
  			
  				//ricavo gli OID per la richiesta successiva
            	for(int i=0; i<tempOIDs.length; i++)
               		tempOIDs[i] = pdu.getObjectID(i).toString();
             }
  		}
  		
  		return rowsHF;
  	}
  	
  	
	boolean isInTable(SnmpPDU pdu)
    {
        PrintStream out = agentSystem.getOut();

        //verifico se la pdu e' nulla (time out)
        if (pdu == null)
        {
            trace_err(out,getHeader()+" NULL PDU in response");
            return false;
        }

        //verifico se la pdu contiene errori
        if (pdu.getErrstat() > 0)
        {
            trace_err(out,getHeader()+" Error occurred in PDU "+pdu.getError());
            pdu.fix();
            return false;
        }

        //verifico se nella pdu di risposta sono contenuti elementi appartenenti alla tabella
        int nvar = (pdu.getVariableBindings()).size();
        int j = 0;
        boolean next = true;

		//confronto l'OID di ogni var della risposta con l'OID corrispondente iniziale
		//es. dovevo recuperare la var 1.3.6.1.2.1.2 e ho 1.3.6.1.2.1.2.9 
		//=> va bene, e' la nona istanza della variabile
        while ((next)&&(j<nvar))
            next = pdu.getObjectID(j++).toString().startsWith(reqOIDs[j]+".");

        return next;
    }  	 
    
    
     //classe d'appoggio nell'implementazione della valutazione di una health function
	 class  ret
	 {
	 	//primo operando
	 	Object ris = null;
	 	//numero parentesi aperte ancora da bilanciare
	 	int nopen = 0;
	 	//collezione dei parametri costituenti l'hf ancora da considerare
	 	Collection rem = null;

	 	ret (String hf)
	 	{
	 		rem = StringToParameters(hf);
	 	}

	 	ret (Collection coll, Object op, int no)
	 	{
	 		rem = coll;
	 		ris = op;
	 		nopen = no;
	 	}
	 }

	ret evalHF(ret info, Hashtable values)
	{
		//recupero primo operando, numero parentesi aperte ancora da bilanciare, collezione di stringhe ancora da valutare
		Object op1 = info.ris;
		int open = info.nopen;
		Collection cHF = info.rem;
		ret next = null;

		//la Collection nella ricorsione dovrebbe risultare modificata
		Iterator iHF = cHF.iterator();

		String firstok = (String)iHF.next();
		iHF.remove();
		String temp = null;
	         if (firstok.equals("("))
		 {
		 	open ++;
		 	temp = (String)iHF.next();
		 	iHF.remove();
		 	//prima scarto tutte le eventuali parentesi aperte innestate e le conto (perche' dovranno essere bilanciate)
		 	while( temp .equals("(") && iHF.hasNext() )
		 	{
		 		open ++;
				temp = (String)iHF.next();
				iHF.remove();
			}
			//quando mi fermo e' perche' ho trovato un operando (variabile Snmp), devo recuperare il valore dalla hashtable
			Object  temp1 = values.get(temp);
			next = new ret(cHF,temp1,open);
			return (evalHF(next,values));
		}
		else if (firstok.equals("*") || firstok.equals("+") || firstok.equals("-") || firstok.equals("/") )
		{
			temp = (String)iHF.next();
		 	iHF.remove();

			Object op2 = null;
			if (temp.equals("(")) //se c'e' ( devo valutare un'altra espressione per ottenere il secondo operando
			         info  = evalHF(new ret(cHF,null,open++),values);
			else   //deve essere il secondo operando
				info = evalHF(new ret(cHF,values.get(temp),open),values);

			op2 = info.ris;
			open = info.nopen;
			cHF = info.rem;

			Object ris = compute(op1,firstok,op2);
			if (open != 0) //ci sono ancora parentesi da bilanciare => stringa non tutta consumata
				return (evalHF(new ret(cHF,ris,open),values));
			else
				return (new ret(cHF,ris,open));

		}
		else if ( firstok.equals(")") )
		{
			open--;
			if (iHF.hasNext())
			{
		 		temp = (String)iHF.next();
		 		iHF.remove();
		 	}
		 	else
		 		return  (new ret(cHF,op1,open));
		 	//prima scarto tutte le eventuali parentesi chiuse innestate e decremento il numero di parentesi aperte che devono
		 	// ancora essere  bilanciate
			while( temp .equals(")") && iHF.hasNext() )
		 	{
		 		open--;
				temp = (String)iHF.next();
				iHF.remove();
			}
			//devo reintrodurre l'ultimo elemento letto che non e' una parentesi chiusa per essere valutato in seguito
			iHF = cHF.iterator();

			//quando esco dal while precedente e' perche' sono finite le parentesi chiuse, restituisco come risultato l'operatore
			//che mi e' stato passato come argomento e che ora puo' essere utilizzato per il calcolo effettivo
			return (new ret(cHF,op1,open));
		}
		else  //c'e' un semplice operando (variabile) di cui mi limito arecuperare il valore
			if (iHF.hasNext()) //ci sara' un operatore
				return evalHF(new ret(cHF, values.get(firstok),open),values);
			return (new ret(cHF,values.get(firstok),open));
	}

	//calcola  "op1 optor op2" , dove op1 ed op2 sono valori che derivano da variabili Snmp, percio' si puo' trattare di Integer o Long
	 Object compute (Object op1,String optor,Object op2)
	 {
	 	if (op1 == null)
	 		return op2;
	 	if (op2 == null)
	 		return op1;

	 	if ( (op1 instanceof Long) && (op2 instanceof Long) )
	 	{
	 		long l1 = ( (Long) op1).longValue();
	 		long l2 = ( (Long) op2).longValue();

	 		if (optor.equals("+"))
	 			return ( new Long( l1+l2 ) );
	 		if (optor.equals("-"))
	 			return ( new Long( l1-l2  ) );
	 		if (optor.equals("*"))
	 			return ( new Long( l1*l2 ) );
	 		if (optor.equals("/"))
				return ( new Long( l1/l2  ) );
	 	}
		if ( (op1 instanceof Integer) && (op2 instanceof Integer)  )
	 	{
	 		int i1 = ((Integer) op1).intValue();
	 		int i2 = ((Integer) op2).intValue();

	 		if (optor.equals("+"))
	 			return ( new Integer( i1+i2  ) );
	 		if (optor.equals("-"))
	 			return ( new Integer( i1-i2  ) );
	 		if (optor.equals("*"))
	 			return ( new Integer( i1*i2  ) );
	 		if (optor.equals("/"))
				return ( new Integer( i1/i2 ) );
		}
	 	return null;
	 }
	 
	/** Converte una stringa contenente una sequenza di parametri
 	 * in una Collection di singoli parametri.
  	*/
  	public Collection StringToParameters( String ParametersLine )
  	{
    		String TokenDelimiters = " ";       // Elenco separatori di items: scartati nella lettura
    		Collection Parameters = new Vector();

    		StringTokenizer stok = new StringTokenizer( ParametersLine, TokenDelimiters , true );

    		try
    		{
      			while( stok.hasMoreTokens() )
      			{
        				String Token = stok.nextToken();

			        if( TokenDelimiters.indexOf( Token ) == -1 )  // Scarto gli spazi
         				 Parameters.add( Token );
      			}
    		}
    		catch( NoSuchElementException  e )
    		{}   // Nessun problema: semplicemente  finita la stringa!

    		//System.out.println( "Parameters: " + Parameters );
    		return Parameters;
 	 }

}