package MobileMonitoring;

import SOMA.naming.*;
import java.io.File;
import java.io.Serializable;

//classe contenente le informazioni di base che un agente mobile, nel ruolo di Manager
//Snmp, deve conoscere per interrogare Agenti Snmp. Si prevedono richieste v3 con
//riferimento alle informazioni contenute nella configurazione del Motore Snmp e v1/v2C.
public class InfoBasedOnConfig extends DrivePlan implements Serializable
{
    //lista dei nomi di sicurezza con i quali l'agente mobile deve presentarsi agli
    //Agenti Snmp che visitera'
    String[] sec_names = null;
    //nome relativo del file di deserializzazione dal quale recuperare, su ogni place visitato,
    //la configurazione del motore Snmp precedentemente stabilita
    //dovra' essere presente su tuti i place
    File serializationFile;

    //costruttore
    //names e' la lista dei nomi di sicurezza con cui l'agente mobile si presenta ai
    //vari agenti Snmp: sara' Community se v1/v2C o nome utente se V3
    //file e' il nome del file di deserializzazione che l'agente mobile deve trovare
    //(deve essere relativo ad una directory presente su tutti i nodi)
    //disponibile su ogni place da visitare, per poter recuperare la configurazione del motore
    public InfoBasedOnConfig(AgentID master,PlaceID[] places, int[] ports, int[] vs, String[] names, String file,boolean deb)
    {
        super(master,places,ports,vs,deb);
        sec_names = names;
        try {serializationFile = new File(file);}
        catch (NullPointerException ne) {}
    }

	//restituisce il file di serializzazione
	public File getFile()
	{
		return serializationFile;
	}
	
    //restituisce il nome assoluto del file di deserializzazione
    public String getAbsFileName()
    {
        return (serializationFile.getAbsolutePath());
    }

    //restituisce la lista dei nomi di sicurezza che l'agente mobile deve utilizzare
    public String[] getSecNames()
    {
        return sec_names;
    }

    //restituisce il nome di sicurezza con cui l'agente mobile deve presentarsi
    //ad un particolare agente Snmp
    //index e' il numero d'ordine dell'agente Snmp (0 il primo, 1 il secondo ..)
    public String getSecName(int index)
    {
        return sec_names[index];
    }

}