package MobileMonitoring;

import StaticMonitoring.Settings;
import MonitorConfig.snmpTable;
import SOMA.agent.*;
import SOMA.naming.*;
import SOMA.utility.*;
import com.adventnet.snmp.snmp2.*;
import java.io.PrintStream;
import java.util.*;
import java.net.*;


public class SnmpFilterTableMA extends SnmpTableMA
{
    //colonna sulla quale deve essere verificata la condizione
    String col = null;
    //valore di riferimento inferiore
    String rif_inf = null;
    //valore di riferimento superiore
    String rif_sup = null;
    //condizione da verificare rispetto al riferimento inferiore
    String cond_inf = null;
    //condizione da verificare rispetto al riferimento superiore
    String cond_sup = null;

    //memorizzo per ogni place visitato, il numero di righe che verificavano la
    //condizione
    int[] match_rows;

    public void putArgument(Object o)
    {
        InfoFiltering Info = (InfoFiltering) o;
        super.putArgument(Info);
        col = Info.getOIDRif();
        rif_inf = Info.getInfVal();
        rif_sup = Info.getSupVal();
        cond_inf = Info.getInfCond();
        cond_sup = Info.getSupCond();
        match_rows = new int[Ntargets];
    }

       /**questo  il metodo di partenza, eseguito all'attivazione dell'agente:
    //qui si avvia il cronometro che conter il tempo necessario al completamento
    //dell'operazione, si definir la prima tappa del "viaggio" e si inizializzer
    //il campo home che dovr poi essere utilizzato per il ritorno al Place
    //di partenza
    */
    public void run()
    {
        super.run();
    }

    /**metodo di passaggio ad una tappa successiva,  qui che si controlla se il viaggio
    // finito, in tal caso si torna al Place di partenza
    */
    public void goNext()
    {
        super.goNext();
    }

        /**metodo di preparazione dell'ambiente locale ai fini dell'adempimento
    //del compito: creazione thread di gestione delle sessioni Snmp, creazione
    //di una sessione Snmp per l'interazione con l'Agente Snmp presente localmente
    //eventuale (caso V3) deserializzazione della configurazione del motore Snmp da file
    */
    /*public void prepareLocalJob()
    {
        prepareLocalJob();
    }*/

    //qui sono racchiuse le operazioni necessarie all'adempimento del compito
    //specifico di questo Agente Mobile
    public void doLocalJob(Settings sets,SnmpSession session)
    {
        snmpTable localtab = FilterTable(sets,session);
        result_code[current] = true;
        job_result.add(current,localtab);

        session.close();
        api.close();
		if (++current != Ntargets)
	        nexthop = targets[current];
        goNext();
    }

    public snmpTable FilterTable(Settings sets,SnmpSession session)
    {
        PrintStream out = agentSystem.getOut();
        //risalgo al numero di colonna costruendo la stringa che rimane se si toglie all'oid della colonna
        //quello della tabella ed il "." es "1.2.3.1" - "1.2.3." --> "1"
        int index = col.lastIndexOf('.');
        String numcol = col.substring(++index);
        int Nc = Integer.parseInt(numcol);
        boolean next = true;
        boolean first = true;
        
        int nrow = 0;
        SnmpPDU ris = new SnmpPDU();
        snmpTable table = new snmpTable(tab,Ncol,debug,out);
        String[] totalOID = getCols();
        while (next)
        {
        	//se e' la prima richiesta devo fare i settaggi
        	//if (first)
        	//{
	            ris = snmpOp(sets,session,totalOID);
	          //  first = false;
	        //}
	        //else //altrimenti la sessione e' gia' utilizzabile
	          //  ris = snmpOp(null,session,totalOID);
	        
            next = (check(ris));
            if (next)
            {
                if (verifyRange(ris.getVariable(Nc-1)))
                {
                    table.addRow(ris);
                    nrow++;
                }
                //recupero gli OID della risposta per utilizzarli nella prossima richiesta
                for(int i=0; i<Ncol; i++)
                    totalOID[i] = ris.getObjectID(i).toString();
            }
            else //errore o risposta non piu' relativa alla tabella
            {
                next = false;
                break;
            }
        }
        match_rows[current] = nrow;
        return table;
    }

     /** verifica la condizione <inf> <condinf> <elem> <condsup> <sup>
    //elem e' la SnmpVar sulla quale si deve fare la verifica
    //condinf e' la condizione inferiore che puo' assumere i valori "<" "<="
    //condsup e' la condizione superiore
    //inf e' il valore di riferimento inferiore
    //sup e' il valore di riferimento superiore
    */
    boolean verifyRange(SnmpVar elem)
    {
        byte eltype = elem.getType();
        int ret1;
        int ret2;
	    //col < rif o col <= rif
        if (rif_inf.equals("ANY"))
            return(verifyCond(elem,cond_sup,rif_sup));
        //rif < col o rif <= col
        if (rif_sup.equals("ANY"))
        {
        	if (cond_inf.endsWith("="))
        		cond_inf = ">=";
			else
				cond_inf = ">";
            return(verifyCond(elem,cond_inf,rif_inf));
        }
        else
        {
            if (eltype == SnmpAPI.INTEGER)
            {
                Integer cur = (Integer)elem.toValue();
                Integer target1 = new Integer(rif_inf);
                Integer target2 = new Integer(rif_sup);
                ret1 = target1.compareTo(cur);
                ret2 = cur.compareTo(target2);

            }
            else if ((eltype == SnmpAPI.COUNTER) || (eltype == SnmpAPI.COUNTER64) ||
                (eltype == SnmpAPI.GAUGE) || (eltype == SnmpAPI.TIMETICKS))
            {
                Long cur = (Long)elem.toValue();
                Long target1 = new Long(rif_inf);
                Long target2 = new Long(rif_sup);
                ret1 = target1.compareTo(cur);
                ret2 = cur.compareTo(target2);
            }
            else if ((eltype == SnmpAPI.BITSTRING) || (eltype == SnmpAPI.IPADDRESS) ||
                (eltype == SnmpAPI.NETWORKADDRESS) || (eltype == SnmpAPI.NSAP) ||
                (eltype == SnmpAPI.OPAQUE) || (eltype == SnmpAPI.STRING) ||
                (eltype == SnmpAPI.OBJID))
            {
                String cur = (String) elem.toString();
                //System.out.println(cur);
                String target1 = new String(rif_inf);
                ret1 = target1.compareTo(cur);
                String target2 = new String(rif_sup);
                ret2 = cur.compareTo(target2);
            }

            else
                return false;

            if ( (verify(ret1,cond_inf)) && (verify(ret2,cond_sup)) )
                return true;

            return false;
        }
    }

    /** verifica la condizione <elem> <cond> <rif>
    //elem e' la SnmpVar sulla quale si deve fare la verifica
    //cond e' la condizione che puo' assumere i valori "<" "<=" ">" ">="
    //rif e' il valore di riferimento
    */
    boolean verifyCond(SnmpVar elem,String cond,String rif)
    {
        byte eltype = elem.getType();
        int ret;

        if (rif.equals("ANY"))
            return true;
        if (eltype == SnmpAPI.INTEGER)
        {
            Integer cur = (Integer)elem.toValue();
            Integer target = new Integer(rif);
            ret = cur.compareTo(target);
        }
        else if ((eltype == SnmpAPI.COUNTER) || (eltype == SnmpAPI.COUNTER64) ||
            (eltype == SnmpAPI.GAUGE) || (eltype == SnmpAPI.TIMETICKS))
        {
            Long cur = (Long)elem.toValue();
            Long target = new Long(rif);
            ret = cur.compareTo(target);
        }
        else if ((eltype == SnmpAPI.BITSTRING) || (eltype == SnmpAPI.IPADDRESS) ||
            (eltype == SnmpAPI.NETWORKADDRESS) || (eltype == SnmpAPI.NSAP) ||
            (eltype == SnmpAPI.OPAQUE) || (eltype == SnmpAPI.STRING) ||
            (eltype == SnmpAPI.OBJID))
        {
            String cur = (String) elem.toString();
            //System.out.println(cur);
            String target = new String(rif);
            ret = cur.compareTo(target);
        }

        else
            return false;

        return (verify(ret,cond));

    }

    boolean verify(int ret,String cond)
    {
        if ( (ret == 0) && ( (cond.equals("=")) || (cond.equals(">=")) || (cond.equals("<=")) ) )
            return true;
        if ((ret < 0) && (cond.startsWith("<")))
            return true;
        if ((ret > 0) && (cond.startsWith(">")))
            return true;

        return false;
    }
}