package MonitorConfig;

import java.util.*;
import java.io.*;
import java.net.*;
import SOMA.naming.*;
import SOMA.naming.place.*;
import SOMA.*;

/** classe contenente le informazioni relative allo stato dei sottomanager di dominio
*   oltre che il suo identificatore necessario per inoltrare richieste
*/
class StatusDomains extends Debug implements Serializable
{
	Hashtable statD = new Hashtable();
	
	protected StatusDomains(PlaceID[] domains)
	{
		//creo le info. a default sul dominio (sottoManager non attivo e agentID nullo)
		info init = new info();
		//creo un'entry per ogni dominio
		for (int j=0; j<domains.length; j++)
		{
		   if (statD.containsKey(domains[j]) == false)
    	   try
     	   {
     	       statD.put(domains[j],init);
     	   }
     	   catch (NullPointerException ex){ }
		}
	}	
	
	protected boolean isOn(PlaceID k)
	{
		info i = (info)statD.get(k);
		return(i.active);
	}
	
	protected boolean setOn(PlaceID k)
	{
        if (statD.containsKey(k))
        {
        	info e = (info)statD.get(k);
        	e.active = true;
            statD.remove(k);
            statD.put(k,e);
            return true;
        }
        return false;
	}
	
	protected boolean setOff(PlaceID k)
	{
        if (statD.containsKey(k))
        {
            statD.remove(k);
            statD.put(k,new info());
            return true;
        }
        return false;
	}

	protected boolean setID(PlaceID k,AgentID id)
	{
		if (statD.containsKey(k))
        {
        	info e = (info)statD.get(k);
        	e.subID = id;
            statD.remove(k);
            statD.put(k,e);
            return true;
        }
        return false;
	}
		
	protected AgentID getID(PlaceID k)
	{
		info i = (info) statD.get(k);
		return (i.subID);
	}
	
	//restituisce gli identificatori di tutti i sottomanager che risultano attivi
	protected Vector getAllOn()
	{
		Vector On = new Vector();
		for (Enumeration e= statD.keys(); e.hasMoreElements();)
		{
			PlaceID dom = (PlaceID)e.nextElement();
			info idom = (info)statD.get(dom);
			if (idom.active)
				On.add(idom.subID);
		}
		return On;
	}
		
	class info
	{
		boolean active;
		AgentID subID;
		
		info()
		{
			active = false;
			subID = null;
		}
		
		info(boolean on,AgentID id)
		{
			active = on;
			subID = id;
		}
	}
	
}