import StaticMonitoring.*;
import MobileMonitoring.*;
import MonitorConfig.*;
import SOMA.*;
import SOMA.agent.*;
import SOMA.naming.*;
import SOMA.naming.place.*;
import SOMA.utility.Chronometer;
import java.util.*;
import java.io.*;
import java.net.InetAddress;
import com.adventnet.snmp.snmp2.*;
import com.adventnet.snmp.mibs.*;

import javax.crypto.*;
import iaik.security.provider.IAIK;

/** Questo agente e' in realta' degenere, perche' destinato a risiedere sul nodo da cui si intendono 
*   monitorare i dispositivi */
  
public class MonitorSNMP extends Agent implements Operations
{
    static String nomeprog = "Monitor";

    static String usage1PF = " 5 [-d debug] [-cf] [-MA mobility] FILTERT RIFinf CONDinf (<,>,>=,<=) OIDcol CONDsup RIFsup \n<nomedominio> <nomeplace>\n[-p port] ";
    static String usage1F = " 2 [-d debug] [-cf] [-MA mobility] FILTERT RIFinf CONDinf (<,>,>=,<=) OIDcol CONDsup RIFsup \n<nomehost> \n[-p port] ";
    static String usage5F = "\n[-t timeout] \n[-r retries] OIDtable";

    static String usage1PW = " 5 [-d debug] [-cf ] [-MA mobility] WALK \n<nomedominio> <nomeplace>\n[-p port] ";
    static String usage1W = " 2 [-d debug] [-cf ] [-MA mobility] WALK \n<nomehost> \n[-p port] ";
    static String usage5W = "\n[-t timeout] \n[-r retries] [startOID]";

    static String usage1PB = " 5 [-d debug] [-cf ] [-MA mobility] GETBULK <nonrep> <maxrep> \n<nomedominio> <nomeplace> \n[-p port] ";
    static String usage1B = " 2 [-d debug] [-cf ] [-MA mobility] GETBULK <nonrep> <maxrep> \n<nomehost> \n[-p port] ";

    static String usage1HF = "2 [-d debug] [-cf ] [-MA mobility] HF \n[-t table]\n<nomehost> \n[-p port] ";
    static String usage1PHF = "5 [-d debug] [-cf ] [-MA mobility] HF \n[-t table]\n<nomedominio> <nomeplace> \n[-p port] ";
    static String usage5HF = "\n[-t timeout] \n[-r retries] health-function (ex. ( snmp.snmpInPkts.0 - snmp.snmpInBadVersions.0 ))";

    static String usage1Pa = " 2 [-d debug] [-cf ] [-MA mobility] POLLER \n<optype  1 (get)/2 (getnext)/3 (getbulk)/5 (getable)/6 (filtert)/9 (hf)/10 (hftable)>";
    static String usage1Pb = "\n<gap (msec)>  <total (msec)>  <extra args> \n<nomehost> \n[-p port] ";
    static String usage1PPa = " 5 [-d debug] [-cf ] [-MA mobility] POLLER \n<optype  1 (get)/2 (getnext)/3 (getbulk)/5 (getable)/6 (filtert)/9 (hf)/10 (hftable)>";
    static String usage1PPb = "\n<gap (msec)>  <total (msec)>  <extra args> \n<nomedominio> <nomeplace> \n[-p port] ";

    static String usage1 = " 2 [-d debug] [-cf] [-MA mobility]  GET/GETNEXT/GETABLE \n<nomehost> \n[-p port] ";
    static String usage1P = " 5 [-d debug] [-cf] [-MA mobility]  GET/GETNEXT/GETABLE \n<nomedominio> <nomeplace>\n[-p port] ";
    static String usage2 = "\n[-cu community/username] \n[-v version (v1/v2/v3)] \n[-a authprotocol (MD5/SHA)] ";
    static String usage3 = "[-aw authpassword] \n[-pp privprotocol CBC_DES] [-pw privpassword] ";
    static String usage4 = "\n[-cx contextname] \n[-cid contextid] ";
    static String usage5 = "\n[-t timeout] \n[-r retries] OID [OID].. [OID]";

    static String usage1MPPa = " 2 [-d debug] [-cf ] [-MA mobility] POLLER \n<optype  1 (get)/2 (getnext)/3 (getbulk)/5 (getable)/6 (filtert)/9 (hf)/10 (hftable)>";
    static String usage1MPPb = "\n<gap (msec)>  <total (msec)>  <extra args> \n<nomehost> \n[-p port] ";
    

    static String usage1MP = " 6 [-d debug] [-MA mobility] GET/GETNEXT/GETABLE/MINMAXAVE \n<numero targets> <nome dominio> <nome place> [-p port] [<nome dom.> <nome place> [-p port] ] .. ";

    static String usage1MPF = " 6 [-d debug] [-MA mobility] FILTERT RIFinf CONDinf (<,>,>=,<=) OIDcol CONDsup RIFsup \n<numero targets> \n<nome dominio> <nome place> [-p port] [<nome dom.> <nome place> [-p port] ] .. ";

    static String usage1MPHF = " 6 [-d debug] [-MA mobility] HF \n[-t table] \n<numero targets> \n<nome dominio> <nome place> [-p port] [<nome dom.> <nome place> [-p port] ] .. ";

    static String usage1MPB = " 6 [-d debug] [-MA mobility] GETBULK <nonrep> <maxrep> \n<numero targets> \n<nome dominio> <nome place> [-p port] [<nome dom.> <nome place> [-p port] ] .. ";
    
    static String usage1MPlPol = "\n<gap (msec)>  <total (msec)>  <extra args> \n<numero targets> \n<nome dominio> <nome place> [-p port] [<nome dom.> <nome place> [-p port] ] .. ";
    static String usage1MPlPola = " 6 [-d debug] [-MA mobility] POLLER \n<optype  1 (get)/2 (getnext)/3 (getbulk)/5 (getable)/6 (filtert)/9 (hf)/10 (hftable)>";

    static String usage1MH = " 7 [-d debug]  [-MA mobility] GET/GETNEXT/GETABLE/MINMAXAVE <numero targets> <nomehost> [-p port] [<nomehost> [-p port] ] .. ";

    static String usage1MHF = " 7 [-d debug]  [-MA mobility] FILTERT RIFinf CONDinf (<,>,>=,<=) OIDcol CONDsup RIFsup \n<numero targets> \n<nomehost> [-p port] [<nomehost> [-p port] ] .. ";
    
    static String usage1MHHF = " 6 [-d debug] [-MA mobility] HF \n[-t table] \n<numero targets> \n<nome host> [-p port] [<nome host> [-p port] ] .. ";

    static String usage1MHB = " 7 [-d debug] [-MA mobility] GETBULK <nonrep> <maxrep> \n<numero targets> \n<nomehost> [-p port] [<nomehost> [-p port] ] .. ";
    static String usage1MHPol = "\n<gap (msec)>  <total (msec)>  <extra args> \n<numero targets> \n<nomehost> [-p port] [<nomehost> [-p port] ] .. ";
    
    static String usage1D = " 6 [-d debug] [-MA mobility] GET/GETNEXT/GETABLE/MINMAXAVE \n<numero targets> \n<nome dominio1> <nome dominio2> .. <nome dominioN>";

    static String usage1DF = " 6 [-d debug] [-MA mobility] FILTERT RIFinf CONDinf (<,>,>=,<=) OIDcol CONDsup RIFsup \n<numero targets> \n<nome dominio1> <nome dominio2> .. <nome dominioN>";

    static String usage1DHF = " 6 [-d debug] [-MA mobility] HF \n[-t table] \n<numero targets> \n<nome dominio1> <nome dominio2> .. <nome dominioN>";

    static String usage1DB = " 6 [-d debug] [-MA mobility] GETBULK <nonrep> <maxrep> \n<numero targets> \n<nome dominio1> <nome dominio2> .. <nome dominioN>";


    //stringhe d'uso per operazioni su 1 host
    static String usage = usage1+usage2+usage3+usage4+usage5;
    static String usageFilter = usage1F+usage2+usage3+usage4+usage5F;
    static String usageBulk = usage1B+usage2+usage3+usage4+usage5;
    static String usageWalk = usage1W+usage2+usage3+usage4+usage5W;
    static String usagePoller = usage1Pa+usage1Pb+usage2+usage3+usage4+usage5;
    static String usageHealth = usage1HF+usage2+usage3+usage4+usage5HF;

    //stringhe d'uso per operazioni su un place
    static String usageP = usage1P+usage2+usage3+usage4+usage5;
    static String usageFilterP = usage1PF+usage2+usage3+usage4+usage5F;
    static String usageBulkP = usage1PB+usage2+usage3+usage4+usage5F;
    static String usageWalkP = usage1PW+usage2+usage3+usage4+usage5W;
    static String usagePollerP = usage1PPa+usage1PPb+usage2+usage3+usage4+usage5;
    static String usageHealthP = usage1PHF+usage2+usage3+usage4+usage5HF;

    //stringhe d'uso per operazioni su piu' place
    static String usageMoreP = usage1MP+usage4+usage5;
    static String usageMorePFilter = usage1MPF+usage4+usage5F;
    static String usageMorePBulk = usage1MPB+usage4+usage5;
    static String usageMorePHF = usage1MPHF+usage5HF;
    static String usageMorePPoll = usage1MPlPola+usage1MPlPol+usage2+usage3+usage4+usage5;
    
    //stringhe d'uso per operazioni su piu' host
    static String usageMoreH = usage1MH+usage4+usage5;
    static String usageMoreHFilter = usage1MHF+usage4+usage5F;
    static String usageMoreHBulk = usage1MHB+usage4+usage5;
    static String usageMoreHF = usage1MHHF+ usage5HF;
    static String usageMoreHPoll = usage1MHPol+usage1PPb+usage2+usage3+usage4+usage5;
    
    //stringhe d'uso per operazioni su domini
    static String usageD = usage1D+usage5;
    static String usageDFilter = usage1DF+usage4+usage5F;
    static String usageDBulk = usage1DB+usage4+usage5;
    static String usageDHF = usage1DHF+usage5HF;
    
    //opzioni per le richieste SNMP:
    //-p porta d'ascolto dell'agente -cu community(v1/2)/userName(v3) -v versioneSNMP -a proto. autenticazione -aw passwd autenticazione
    //-pp proto. privacy -pw passwd privacy -cx nome contesto -cid identificatore contesto -t timeout di risposta
    //-r numero tentativi di richiesta
    static String options[] = {"-p","-cu","-v","-a","-aw","-pp","-pw","-cx","-cid","-t","-r"};

   	Environment env = null;
   	//hashtable in cui inserisco i place di ogni dominio noto 
   	//(se l'appl. viene eseguita su default place)
	Hashtable dom_places = null;
	//configurazione di riferimento nell'esecuzione dell'applicazione
	Configuration config = null;
	//manager statico di riferimento per richieste C/S: a fronte di richiesta C/S si attivano i suoi metodi
	StaticManager manager = null;
	
	PrintStream out = System.out;
    InputStream in = System.in;
    
    String Header = "";
    String location = "";
    String identity = "";

    //attributo da utilizzare nella creazione di agenti mobili delegati
	boolean systemloader = false;

	//in generale creero' agenti mobili delegati non rintracciabili per non appesantire troppo
	//anche perche' le informazioni reperite vengono restituite solo una volta tornati al nodo
	//di partenza
    boolean traceable = false;

	//N.B. i successivi due attributi dovranno essere settati all'inizializzazione
    //static String dirmibs = "//export//home//cgentili//Tesi//mibs//";
    static String dirmibs = "c:chiara\\tesi\\mibs\\";
    
    //nome del file di serializzazione per i dati di utente v3
    static String serfile = "USMser.ser";

    //attributo di stato del debugging
    boolean debug = false;
    //attributo che indica l'utilizzo di naming SOMA (true) o di host:porta (false)
    boolean soma = false;
    //attributo che indica l'utilizzo di Agenti Mobili o l'utilizzo di modalita' C/S
    // mobility == true => preparazione informazioni, creazione e attivazione agente mobile opportuno
    // mobility == false => attivazione metodo di "manager"
    boolean mobility = false;

    boolean Continue = true;
	char request;
	String[] params = null;

	//cronometro per misurare i tempi di risposta
	Chronometer Crono = new Chronometer("misure");

	public void putArgument(Object obj)
	{

    }

    public void run()
    {
        //aggiungo IAIK come security provider
        IAIK.addAsProvider(true);

    	//ricavo le variabili associate all'ambiente locale
        out = agentSystem.getOut();
        in = agentSystem.getIn();
        env = agentSystem.getEnvironment();
        
        //all'inizializzazione, se sono su place di default, recupero anche i place corrispondenti a ogni dominio noto
        //N.B. e' un'informazione a cui non posso giungere direttamente, lo faccio usando un agente mobile
        if (getID().place.isDomain())
	        dom_places = discoverPlaces();
        
        config = new Configuration(env.placeNameService, env.domainNameService, debug, out);
		
		//inizializzo locazione di partenza, identita' dell'agente corrente,
		//header per i messaggi di output
		location = agentSystem.getPlaceID().toString();
        identity = "\""+getID().toString()+"\"";
		Header = "@@@@@ "+identity+" on "+location+": ";

        out.println("Setting MIB files directory: "+dirmibs);
        config.setDirMibs(dirmibs);
		out.println();
		out.println("Inizializing Application.......");
        //creo lo StaticManager che gestira' le varie sessioni d'interazione nell'ambito di richieste C/S
        manager = new StaticManager(config,false,debug,out);
		out.println();
        //out.println("Loading default MIB: RFC1213-MIB");
		//manager.loadMIB("RFC1213-MIB");

        BufferedReader brIn = new BufferedReader(new InputStreamReader(in));
        boolean again = true;
        String Linea = null;
        showmenu();
        String location = "**** MonitorSNMP running on "+agentSystem.getPlaceID().toString()+"****";

		out.println(location);


        try
        {
            while (Continue)
     		{
     			out.println();
     			out.println();
     			Linea = brIn.readLine();
     			if (Linea.length() == 0)
     				showmenu();
     			else
     			{
     			//recupero il tipo di richiesta
     			request = Linea.charAt(0);
     			System.out.println("Scelta "+request);

				//creo una Collection di parametri a partire da cio' che rimane della linea di input
				Collection params = StringToParameters(Linea.substring(1));

            	switch (request)
        		{
            		case '0':
                		Discovery(params);
                		break;
            		case '1':
            			distributeConfiguration();
                		break;
           			case '2':
           				soma = false;
            		    oneTargetOps(false,params);
             		    break;
           			case '3':
           				out.println("Loaded: "+loadMibs(params)+" MIB files");
                		break;
            		case '4':
	            		Configure();
               			break;
            		case '5':
            			soma = true;
            			oneTargetOps(soma,params);
            			break;
          			case '6':
          				soma = true;
            			multiTargetOps(soma,params);
            			break;
            		case '7':
            			soma = false;
            			multiTargetOps(soma,params);
            			break;
            		case '8':
            			soma = true;
            			domainOps(params);
            			break;
            			
          			case 'X':
          			    //disattivo gli eventuali sottomanager di dominio attivi
          				deactivateSubM();
          				Continue = false;
          				break;

           			default:
                		out.println("Code Request error");
                		showmenu();
               			break;
        		}
        		}
       		}
      }
      catch (IOException e) { return;}
    }


	void showmenu()
	{
		out.println("Operazioni disponibili:");
        out.println("Discovery di versione --> 0");
        out.println("Operazioni su 1 target host --> 2");
        out.println("Caricamento moduli mib  --> 3");
        out.println("Configurazione  --> 4");
        out.println("Operazioni su 1 target  place (<nome dominio> <nome place>) --> 5");
        out.println("Operazioni su piu' place  --> 6");
        out.println("Operazioni su piu' hosts  --> 7");
        out.println("Operazioni su dominio  --> 8");
        out.println("Exit --> X");
	}

    void Discovery(Collection args)
    {
    	//non mi serve attingere alla configurazione
        boolean conf = false;
        String host;
        //valore di default della porta d'ascolto dell'agente Snmp, in caso non venga specificata
        int snmport = 161;
        int port = snmport;
        int version;

        String usage = "Usage:  <numero scelta> <nomehost> [-p port] [<nomehost>] [-p port]..";
        if (args.size() == 0)
        {
            out.println(usage);
            return;
        }

        //manager.startEngine(false,debug,out);

        Iterator ParametersIterator = args.iterator();

    	while( ParametersIterator.hasNext() )
    	{
      		String param = (String)ParametersIterator.next();

            if (param.charAt(0) == '-')
            {
                out.println(usage);
                return;
            }

            host = param;
       		ParametersIterator.remove();

       		if (args.size() >= 2)
       		{
				param = (String)ParametersIterator.next();
        	    if (param.equals("-p"))
        	    {
   	     	  		ParametersIterator.remove();       // Tolgo la key.
					param = (String)ParametersIterator.next();
          	   	  	try{ port = Integer.parseInt(param);}
              		catch(NumberFormatException e){out.println(usage);return;}
	       			ParametersIterator.remove();       // Tolgo la key.
            	}
            	else
            		ParametersIterator = args.iterator();
            }

            config.addEngine(host,port);
            version = manager.discoverAgentVersion(host,port);
            if (version == -1)
                out.println("Problems in version detecting");
            else
                out.println("Snmp Agent listening on: ("+host+":"+port+") supports Snmpv"+version);
            port = snmport;
        }

        return;
    }

	//DISPATCHER delle OPERAZIONI su 1 TARGET
    void oneTargetOps(boolean soma,Collection args)
    {
		boolean conf = false;
		String usagethisH = usage+"\n"+usageBulk+"\n"+usageWalk+"\n"+usageFilter+"\n"+usagePoller+"\n";
		String usagethisP = usageP+"\n"+usageBulkP+"\n"+usageWalkP+"\n"+usageFilterP+"\n"+usagePollerP+"\n";
		String usagethis = usagethisH+"\n\n"+usagethisP;

        String oids[];
        int i = 0;

		//config.restoreConfiguration();

        if (args.size() == 0)
        	if (soma)
        	{
           		out.println(usageP+"\n");
           		out.println(usageBulkP+"\n");
           		out.println(usageWalkP+"\n");
           		out.println(usageFilterP+"\n");
           		out.println(usagePollerP+"\n");
           		out.println(usageHealthP+"\n");
           		return;
            }
            else
        	{
            	out.println(usage+"\n");
            	out.println(usageBulk+"\n");
       		    out.println(usageWalk+"\n");
        	    out.println(usageFilter+"\n");
         	    out.println(usagePoller+"\n");
      			out.println(usageHealth+"\n");
         	    return;
            }

        Iterator ParametersIterator = args.iterator();

    	//recupero le opzioni comuni a qualunque richiesta: stato del debugging, tipo di naming,
    	//utilizzo delle informazioni di configurazione
        String values[] = new String[Settings.NMAXOPTIONS];

		String param = (String)ParametersIterator.next();
		if (param.equals("-d"))
        {
        	manager.setDebug(true);
        	debug = true;
        	ParametersIterator.remove();
        }
        else
        {
        	manager.setDebug(false);
        	debug = false;
            ParametersIterator = args.iterator();
        }

        param = (String)ParametersIterator.next();
        if (param.equals("-cf"))
        {
        	conf = true;
			ParametersIterator.remove();
            config.restoreConfiguration();
        }
		else
		{
			conf = false;
	        ParametersIterator = args.iterator();
		}

        param = (String)ParametersIterator.next();
        if (param.equals("-MA"))
        {
        	mobility = true;
        	ParametersIterator.remove();
        }
        else
        {
        	mobility = false;
            ParametersIterator = args.iterator();
        }

        //recupero il tipo di operazione richiesta e chiamo la funzione corrispondente passando
        //come parametri le informazioni fino a qui recuperate e cio' che rimane della Collection
        //(parametri di input non ancora processati)
       	param = (String)ParametersIterator.next();
       	ParametersIterator.remove();

      	System.out.println("OPZIONI GENERALI: soma: "+soma+" conf: "+conf+" MA: "+mobility+" ");
        if (param.equals("GET"))
        {	
        	if (args.size() < 2)
            {
            	if (soma)
            		out.println(usageP);
            	else
	                out.println(usage);
                return;
            }
            snmpAtomicOp(GET,soma,conf,mobility,args);
        }
        else if (param.equals("GETNEXT"))
        {
            if (args.size() < 2)
            {
            	if (soma)
            		out.println(usageP);
            	else
	                out.println(usage);
                return;
            }
            snmpAtomicOp(GETNEXT,soma,conf,mobility,args);
        }
        else if (param.equals("GETBULK"))
        {
            if (args.size() < 4)
            {
            	if (soma)
            		out.println(usageBulkP);
            	else
	                out.println(usageBulk);
                return;
            }
            snmpAtomicOp(GETBULK,soma,conf,mobility,args);
        }
        else if (param.equals("WALK"))
        {
            if (args.size() < 1)
            {
            	if (soma)
            		out.println(usageWalkP);
            	else
	                out.println(usageWalk);
                return;
            }
        	snmpWalk(soma,conf,mobility,args);
        }
        else if (param.equals("GETABLE"))
        {
            if (args.size() < 2)
            {
            	if (soma)
            		out.println(usageP);
            	else
	                out.println(usage);
                return;
            }
            tableOp(false,soma,conf,mobility,args);
        }
        else if (param.equals("FILTERT"))
        {
            if (args.size() < 7)
            {
            	if (soma)
            		out.println(usageFilterP);
            	else
	                out.println(usageFilter);
                return;
            }
            tableOp(true,soma,conf,mobility,args);
        }
        else if (param.equals("POLLER"))
        	Polling(soma,conf,mobility,args);
        	
        else if (param.equals("HF"))
            healthOp(soma,conf,mobility,args);
            
        else
        {
            out.println("Invalid Operation Request");
            out.println(usagethis);
            return;
        }

        return;

    }
    
    //CARICAMENTO dei MODULI MIB
    //es. 3 RFC1213-MIB --> carica il file "RFC1213-MIB" presente nella dir. specificata in dirmibs
    int loadMibs(Collection mibfiles)
    {
        Iterator ParametersIterator = mibfiles.iterator();
		int nloaded = 0;

		String usage = "Usage:  <numero scelta> <MIB file 1> <MIB file 2> ... <MIB file N>";
        if (mibfiles.size() == 0)
        {
            out.println(usage);
            return 0;
        }

		out.println("Loading MIB files........");
    	while( ParametersIterator.hasNext() )
    	{
      		String file = (String)ParametersIterator.next();

			if (config.loadMIB(file))
			{
				out.println(file+" loaded..");
				nloaded++;
			}
       		ParametersIterator.remove();
       	}

       	return nloaded;
    }

    //In questo metodo ho racchiuso l'introduzione delle informazioni da serializzare    
    //basta invocarlo una volta se si vuole che anche nelle esecuzioni successive le stesse informazioni 
    //siano disponibili automaticamente (tramite deserializzazione)
    void Configure()
    {
        String[] mib = new String[1];
        mib[0] = "RFC1213-MIB";

        String[] mibs_host = new String[3];
        mibs_host[0] = "RFC1213-MIB";
        mibs_host[1] = "HOST-RESOURCES-MIB";
        mibs_host[2] = "UCD-SNMP-MIB.txt";
        //mibs_host[2] = "SUN-MIB";

        String[] mibs_router = new String[1];
        mibs_router[0] = "RFC1213-MIB";

    	PlaceID p8 = new PlaceID("d","d18");
		String h8 = "dida18.deis.unibo.it";
		
		PlaceID p9 = new PlaceID("d","d13");
		String h9 = "dida13.deis.unibo.it";

		PlaceID p10 = new PlaceID("d","d12");
		String h10 = "dida12.deis.unibo.it";
		
		out.println("CREATING PERMANENT CONFIGURATION.............");
        out.println("Avvio il motore senza deserializzare la configurazione");

        out.println("Place noti:");
        //out.println(p8.toString()+" "+SnmpAPI.SNMP_VERSION_3+" 161 chiara");
        out.println(p8.toString()+" "+SnmpAPI.SNMP_VERSION_2C+" 161 public");
        out.println(p9.toString()+" "+SnmpAPI.SNMP_VERSION_2C+" 161 public");
        out.println(p10.toString()+" "+SnmpAPI.SNMP_VERSION_2C+" 161 public");
        
        out.println("Aggiungo gli Agenti Snmp noti");
        //config.addHostSnmp(h8,161,SnmpAPI.SNMP_VERSION_3,"chiara",p8);
        config.addHostSnmp(h8,161,SnmpAPI.SNMP_VERSION_2C,"public",p8);
        config.addHostSnmp(h9,161,SnmpAPI.SNMP_VERSION_2C,"public",p9);
        config.addHostSnmp(h10,161,SnmpAPI.SNMP_VERSION_2C,"public",p10);
        
        out.println("Aggiungo i Mib files supportati dagli agenti Snmp noti:");
        config.addMibsNode("dida18.deis.unibo.it",161,mibs_host);
        config.addMibsNode("dida13.deis.unibo.it",161,mibs_host);
        config.addMibsNode("dida12.deis.unibo.it",161,mibs_host);
        
        //out.println("Aggiungo gli utenti v3 alla tabella USM");
        //config.addUser("chiara","MD5","cgentili",h8,161);
        //config.addUser("initial","132.208.135.189",10000);
        
        out.println("Setto il file di serializzazione USM");
        config.setUSMserFile();
        
        //serializzo e deserializzo per verificare se tutto funziona..
        out.println("Serializzazione");
        config.saveConfiguration();
        out.println("Deserializzazione");
        config.restoreConfiguration();
        
        out.println("**********************************");
        out.println("CONTENUTO della TABELLA UTENTI v3:");
        config.showConfiguredV3Users();
        out.println("******************************************");
        out.println("CONTENUTO della TABELLA dei MOTORI SnmpV3:");
        config.showConfiguredEngines();
        out.println("*******************************************");
        out.println("CONTENUTO della TABELLA dei MIB SUPPORTATI:");
        config.showSupportedMibStructure();
        out.println("**************************************************"	);
        out.println("CONTENUTO della TABELLA degli AGENTI Snmp CONFIGURATI");
        config.showHostsConfiguration();

    }

	//DISPATCHER delle OPERAZIONI su PIU' TARGET
	void multiTargetOps(boolean soma, Collection args)
	{
		//per richieste su piu' targets utilizzo sempre la configurazione
		boolean conf = true;

        String oids[];
        int i =0;

		//quando ho piu' target do' per scontato che si usi la configurazione
		config.restoreConfiguration();

        if (args.size() == 0)
        if (soma)
        {
            out.println(usageMoreP+"\n");
            out.println(usageMorePBulk+"\n");
            out.println(usageMorePFilter+"\n");
            out.println(usageMorePHF+"\n");
            out.println(usageMorePPoll+"\n");
            return;
        }
        else
        {
            out.println(usageMoreH+"\n");
            out.println(usageMoreHBulk+"\n");
            out.println(usageMoreHFilter+"\n");
            out.println(usageMoreHF+"\n");
            out.println(usageMoreHPoll+"\n");
            return;
        }

        Iterator ParametersIterator = args.iterator();

    	//recupero le opzioni comuni a qualunque richiesta: stato del debugging, tipo di naming,
        String values[] = new String[Settings.NMAXOPTIONS];

		String param = (String)ParametersIterator.next();
		if (param.equals("-d"))
        {
        	manager.setDebug(true);
        	debug = true;
        	ParametersIterator.remove();
        }
        else
        {
        	manager.setDebug(false);
        	debug = false;
            ParametersIterator = args.iterator();
        }
 
        param = (String)ParametersIterator.next();
        if (param.equals("-MA"))
        {
        	mobility = true;
        	ParametersIterator.remove();
        }
        else
        {
        	mobility = false;
            ParametersIterator = args.iterator();
        }

      	System.out.println("OPZIONI GENERALI: soma: "+soma+" MA: "+mobility+" ");
        //recupero il tipo di operazione richiesta e chiamo la funzione corrispondente passando
        //come parametri le informazioni fino a qui recuperate e cio' che rimane della Collection
        //(parametri di input non ancora processati)
       	param = (String)ParametersIterator.next();
       	ParametersIterator.remove();
       	//String[] argsop = (String[])args.toArray();

        if (param.equals("GET"))
        {
        	if (args.size() < 3)
            {
            	if (soma)
	                out.println(usageMoreP);
	            else
	                out.println(usageMoreH);
                return;
            }
            snmpMultiAtomicOp(GET,soma,mobility,args);
        }
        else if (param.equals("GETNEXT"))
        {
            if (args.size() < 3)
            {
            	if (soma)
	                out.println(usageMoreP);
	            else
	                out.println(usageMoreH);
                return;
            }
            snmpMultiAtomicOp(GETNEXT,soma,mobility,args);
        }
        else if (param.equals("GETBULK"))
        {
            if (args.size() < 5)
            {
            	if (soma)
	                out.println(usageMorePBulk);
	            else
	                out.println(usageMoreHBulk);
                return;
            }
            snmpMultiAtomicOp(GETBULK,soma,mobility,args);
        }
        else if (param.equals("MINMAXAVE"))
        {
        	if (args.size() < 3)
        	{
            	if (soma)
	                out.println(usageMoreP);
	            else
	                out.println(usageMoreH);
        		return;
        	}
            snmpMultiAtomicOp(MINMAXAVE,soma,mobility,args);
        }
        else if (param.equals("GETABLE"))
        {
            if (args.size() < 3)
            {
            	if (soma)
	                out.println(usageMoreP);
	            else
	                out.println(usageMoreH);
	            return;
            }
            MultitableOp(false,soma,mobility,args);
        }
        else if (param.equals("FILTERT"))
        {
            if (args.size() < 7)
            {
            	if (soma)
	                out.println(usageMorePFilter);
	            else
	                out.println(usageMoreHBulk);
                return;
            }
            MultitableOp(true,soma,mobility,args);
        }
		else if (param.equals("HF"))
			MultiHFOp(soma,mobility,args);
		else if (param.equals("POLLER"))
			MultiPolling(soma,mobility,args);	
        return;
	}
	
	
	//DISPATCHER delle OPERAZIONI su DOMINIO (cioe' che coinvolgono tutti i place di un dominio)
	void domainOps(Collection args)
	{
		//per richieste su piu' targets utilizzo sempre la configurazione
		boolean conf = true;

        String oids[];
        int i =0;

		//quando ho piu' target do' per scontato che si usi la configurazione
		config.restoreConfiguration();

        if (args.size() == 0)
        {
            out.println(usageD+"\n"); 
            out.println(usageDFilter+"\n");
            out.println(usageDHF+"\n");
            out.println(usageDBulk+"\n");
            return;
        }

        Iterator ParametersIterator = args.iterator();

    	//recupero le opzioni comuni a qualunque richiesta: stato del debugging, tipo di naming,
        String values[] = new String[Settings.NMAXOPTIONS];

		String param = (String)ParametersIterator.next();
		if (param.equals("-d"))
        {
        	manager.setDebug(true);
        	debug = true;
        	ParametersIterator.remove();
        }
        else
        {
        	manager.setDebug(false);
        	debug = false;
            ParametersIterator = args.iterator();
        }

        param = (String)ParametersIterator.next();
        if (param.equals("-MA"))
        {
        	mobility = true;
        	ParametersIterator.remove();
        }
        else
        {
        	mobility = false;
            ParametersIterator = args.iterator();
        }

      	System.out.println("OPZIONI GENERALI: soma: "+soma+" MA: "+mobility+" ");
        //recupero il tipo di operazione richiesta e chiamo la funzione corrispondente passando
        //come parametri le informazioni fino a qui recuperate e cio' che rimane della Collection
        //(parametri di input non ancora processati)
       	param = (String)ParametersIterator.next();
       	ParametersIterator.remove();
       	//String[] argsop = (String[])args.toArray();

        if (param.equals("GET"))
        {
        	if (args.size() < 3)
        	{
	            out.println(usageD);
                return;
            }
            snmpDomainAtomicOp(GET,mobility,args);
        }
 /*       else if (param.equals("GETNEXT"))
        {
            if (args.size() < 3)
            {
            	if (soma)
	                out.println(usageMoreP);
	            else
	                out.println(usageMoreH);
                return;
            }
            snmpMultiAtomicOp(GETNEXT,soma,mobility,args);
        }
        else if (param.equals("GETBULK"))
        {
            if (args.size() < 5)
            {
            	if (soma)
	                out.println(usageMorePBulk);
	            else
	                out.println(usageMoreHBulk);
                return;
            }
            snmpMultiAtomicOp(GETBULK,soma,mobility,args);
        }
        else if (param.equals("MINMAXAVE"))
        {
        	if (args.size() < 3)
        	{
            	if (soma)
	                out.println(usageMoreP);
	            else
	                out.println(usageMoreH);
        		return;
        	}
            snmpMultiAtomicOp(MINMAXAVE,soma,mobility,args);
        }
        else if (param.equals("WALK"))
        {
            if (args.size() < 2)
            {
                out.println(usageWalk);
                return;
            }
        	snmpMultiWalk(soma,mobility,argsop);
        }
        else if (param.equals("GETABLE"))
        {
            if (args.size() < 3)
            {
            	if (soma)
	                out.println(usageMoreP);
	            else
	                out.println(usageMoreH);
	            return;
            }
            MultitableOp(false,soma,mobility,args);
        }
        else if (param.equals("FILTERT"))
        {
            if (args.size() < 7)
            {
            	if (soma)
	                out.println(usageMorePFilter);
	            else
	                out.println(usageMoreHBulk);
                return;
            }
            MultitableOp(true,soma,mobility,args);
        }
		else if (param.equals("HF"))
			MultiHFOp(soma,mobility,args);
		*/	
        return;
	}

   //DISPATCHER per le OPERAZIONI ATOMICHE GET/GETNEXT/GETBULK
   public void snmpAtomicOp(int op,boolean soma, boolean conf, boolean mobility, Collection args)
   {
        Iterator ParametersIterator = args.iterator();
   		String nonrep = null;
   		String maxrep = null;
        String values[] = new String[Settings.NMAXOPTIONS];
        String host = null;
        PlaceID placeID = null;
        String[] oids = null;
        String extra[] = null;

   		if (op == GETBULK)
   		{
            nonrep = (String)ParametersIterator.next();
        	ParametersIterator.remove();
            maxrep = (String)ParametersIterator.next();
        	ParametersIterator.remove();
            out.println("Nonrep: "+nonrep+" Maxrep: "+maxrep);
   		}

        String param = (String)ParametersIterator.next();
        //se c'e' subito un'opzione e' sbagliato, e' obbligatorio specificare
		//il target
		if ( param.charAt(0) == '-')
        {
            out.println(usage);
            return;
        }
		//se si usa il naming di soma si avra' il nome di dominio ed il nome del place
		if (soma)
		{
			//recupero nome dominio
			String dominio = param;
			ParametersIterator.remove();
			//recupero nome place
			String place = (String)ParametersIterator.next();
			ParametersIterator.remove();
			placeID = new PlaceID(dominio,place);
			out.println("Dominio: "+dominio+" Place: "+place);
		}
		else
		{
			//recupero nome host
			host = param;
			ParametersIterator.remove();
			out.println("Host: "+host);
	    }
        //i parametri che rimangono nella Collection sono quelli corrispondenti alle variabili
        //static della classe Settings
        String[] rem = (String[])args.toArray(new String[0]);

        Settings sets = new Settings(debug,out);
        oids = sets.parseArguments(rem,options,values,usage);
        int port = 161;
        if (values[Settings.PORT] != null)
        	port = Integer.parseInt(values[Settings.PORT]);

        if (oids == null)
        {
            out.println(usage);
            return;
        }

        out.println("Port: "+port);
        for (int k=0; k<values.length; k++)
            System.out.println(options[k]+": "+values[k]);


        if (soma)
        {
       		 if (config.getNumericOIDs(placeID,port,oids) == false)
        	 {
        			out.println("Impossible to resolve all symbolic oids");
        			return;
        	 }
        }
	    else
     		 if (config.getNumericOIDs(host,port,oids) == false)
        	 {
        			out.println("Impossible to resolve all symbolic oids");
        			return;
        	 }

	    SnmpPDU pdu = new SnmpPDU();
        switch (op)
        {
            case GET:
	            if (soma)
	            	if (mobility)
	            	{
	            		PlaceID[] places = new PlaceID[1];
	            		places[0] = placeID;
	            		int[] ports = new int[1];
	            		ports[0] = port;
	            		snmpMGet(places,ports,oids);
	            		return;
	            	}
	            	else
	            	{
	            		Crono.Start();
	            		out.println("");
	            		out.println("");
		            	pdu = manager.snmpGet(placeID,values,oids,conf);
		            	Crono.Stop();
		            	System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
		            }
	            else
	            {
            		Crono.Start();
	                pdu = manager.snmpGet(host,values,oids,conf);
		           	Crono.Stop();
		           	System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
		        }
                break;

            case GETNEXT:
            	if (soma)
            		if (mobility)
	            	{
	            		PlaceID[] places = new PlaceID[1];
	            		places[0] = placeID;
	            		int[] ports = new int[1];
	            		ports[0] = port;
	            		snmpMGetNext(places,ports,oids);
	            		return;
	            	}
	            	else
	            	{
            			Crono.Start();
	            		out.println("");
	            		out.println("");
	            		pdu = manager.snmpGetNext(placeID,values,oids,conf);
		           		Crono.Stop();
		           		System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
		        }
            	else
            	{
            		Crono.Start();
            		pdu = manager.snmpGetNext(host,values,oids,conf);
		           	Crono.Stop();
		           	System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
            	}
            	break;

            case GETBULK:
            	if (soma)
            		if (mobility)
	            	{
	            		PlaceID[] places = new PlaceID[1];
	            		places[0] = placeID;
	            		int[] ports = new int[1];
	            		ports[0] = port;
	            		snmpMGetBulk(places,ports,oids,nonrep,maxrep);
	            		return;
	            	}
	            	else
            		{
            			Crono.Start();
	            		out.println("");
	            		out.println("");
	            		pdu = manager.snmpGetBulk(placeID,values,oids,nonrep,maxrep,conf);
		           		Crono.Stop();
		           		System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
            		}
            	else
            	{
           			Crono.Start();
	            	pdu = manager.snmpGetBulk(host,values,oids,nonrep,maxrep,conf);
	           		Crono.Stop();
		           	System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
            	}
                break;

        }

        if  (pdu == null)
        {
            System.err.println("time-out");
            return;
        }
        manager.checkPDU(pdu);
        if (pdu != null)
	        config.outPDU(pdu);

        return;

   }
   
   //DISPATCHER PER HF SU 1 TARGET
   public void healthOp(boolean soma, boolean conf, boolean mobility, Collection args)
   {
   	 	Iterator ParametersIterator = args.iterator();
        String values[] = new String[Settings.NMAXOPTIONS];
        String host = null;
        PlaceID placeID = null;
		
		boolean table = false;	
        String param = (String)ParametersIterator.next();
        
        //se e' specificata l'opzione "-t" si deve calcolare il valore dell'HF per ogni riga di una tabella
        if (param.equals("-t"))
        {
        	table = true;
        	ParametersIterator.remove();
        	param = (String)ParametersIterator.next();
        }
        
        //se c'e' subito un'opzione e' sbagliato, e' obbligatorio specificare
		//il target
		if ( param.charAt(0) == '-')
        {
            out.println(usage);
            return;
        }
		//se si usa il naming di soma si avra' il nome di dominio ed il nome del place
		if (soma)
		{
			//recupero nome dominio
			String dominio = param;
			ParametersIterator.remove();
			//recupero nome place
			String place = (String)ParametersIterator.next();
			ParametersIterator.remove();
			placeID = new PlaceID(dominio,place);
			out.println("Dominio: "+dominio+" Place: "+place);
		}
		else
		{
			//recupero nome host
			host = param;
			ParametersIterator.remove();
			out.println("Host: "+host);
	    }
        //i parametri che rimangono nella Collection sono quelli corrispondenti alle variabili
        //static della classe Settings
        String[] rem = (String[])args.toArray(new String[0]);

        Settings sets = new Settings(debug,out);
        String[] extra = sets.parseArguments(rem,options,values,usage);
        //l'array di stringhe e' in questo caso la stringa che rappresenta l'HF
        //devo ricostruire un'unica stringa.. non tanto bello!!
        String HF = new String("");
        for (int i=0; i< extra.length; i++)
        	HF = HF+" "+extra[i];

        int port = 161;
        if (values[Settings.PORT] != null)
        	port = Integer.parseInt(values[Settings.PORT]);

		//il risultato sara' un Integer/Long se si calcola l'HF semplice
		//sara' una Hashtable di oid_riga --> valore HF se si calcola la HF per ogni riga di una tabella
        Object result = null;
        if (soma)
        	if (mobility)
        	{
        		PlaceID[] places = new PlaceID[1];
        		places[0] = placeID;
        		int[] ports = new int[1];
        		ports[0] = port;
        		Object[] ris = new Object[1];
        		ris = snmpMHF(places,ports,HF,table);
        		result = ris[0];
        		return;
        	}
        	else
           	{
        		Crono.Start();
        		if (table)
	       			result = manager.snmpHFTable(placeID,values,HF,conf);
	       		else
	       			result = manager.snmpHF(placeID,values,HF,conf);
        		Crono.Stop();
		   		System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
           	}
		else
		{
        	Crono.Start();
       		if (table)
       			result = manager.snmpHFTable(host,values,HF,conf);
       		else
       			result = manager.snmpHF(host,values,HF,conf);
        	Crono.Stop();
		   	System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
        }
            
        if (table) //risultato e' Hashtable di nome riga --> valore HF di riga
        {
        	out.println("Identificatore Riga: valore HF sulla riga");
        	Hashtable hash = (Hashtable)result;
        	for (Enumeration e = hash.keys(); e.hasMoreElements();)
        	{
        		Object rowid = (Object) e.nextElement(); 
        		Object valrow = (Object)hash.get(rowid);
        		out.println(rowid+": "+valrow);
        	}
        }
        else
        {
			out.println("HF: "+HF);
			out.println("Health Function Value: "+ result);
		}
		return;

	}


	//DISPATCHER per HF su PIU' TARGET
	public void MultiHFOp(boolean soma, boolean mobility, Collection args)
	{
	    Iterator ParametersIterator = args.iterator();
        String values[] = new String[Settings.NMAXOPTIONS];
        String[] hosts = null;
        PlaceID[] places = null;
        int[] ports = null;
        String[] oids = null;
        
        boolean table = false;
        Object result[];

        //deserializzo se non e' stato gia' fatto perche' per questo tipo di operazioni mi appoggio
        //sempre alla configurazione
        config.restoreConfiguration();

        String param = (String)ParametersIterator.next();
        if (param.equals("-t"))
        {
        	table = true;
        	ParametersIterator.remove();
        	param = (String)ParametersIterator.next();
        }
        
        //se c'e' subito un'opzione e' sbagliato, e' obbligatorio specificare
		//il target
		if ( param.charAt(0) == '-')
        {
            out.println(usageMorePHF);
            return;
        }

        int Ntargets;
        try{
        	Ntargets = Integer.parseInt(param);
        	out.println(Ntargets);
        	ParametersIterator.remove();
           }
        catch(NumberFormatException e)
        {
           	out.println(usageMoreP);
        	return;
		}

		Vector v1 = new Vector();
		Vector v2 = new Vector();
		Enumeration e1;
		Enumeration e2;

		//preparo il prossimo parametro
		param = (String)ParametersIterator.next();

        //leggo i nomi dei targets (dom.+place)/IP hosts e le eventuali porte associate
       	//adesso dovrei avere almeno 1 nome place(di default)/1 host 1 OID e comunque non subito opzioni
       	if ((args.size() < 2) || (param.charAt(0) == '-'))
       	{
       		out.println(usageMoreP);
       		return;
       	}
       	else
       	for (int k=0; k<Ntargets; k++)
       	{
       		if (soma)
       		{
       			String dominio = param;
       			ParametersIterator.remove();
       			param = (String)ParametersIterator.next();

				//CORREGGERE: potrebbe trattarsi di un place di default --> solo 1 nome
				if (param.charAt(0) == '-')
				{
        			out.println(usageMoreP);
        			return;
        		}

        		String place = param;
        		ParametersIterator.remove();

        		v1.add(new PlaceID(dominio,place));
				System.out.println("Dominio: "+dominio+" Place: "+place);
			}
			else //non soma
			{
	        	v1.add(param);
				System.out.println("Host: "+param);
	        	ParametersIterator.remove();
	        }

	        if (args.size() >= 2)
	        {
				//controllo se e' stata specificata anche una porta
				param = (String)ParametersIterator.next();
				if (param.charAt(0) == '-')
				{
					if (param.equals("-p"))
					{
        				ParametersIterator.remove();
        				param = (String)ParametersIterator.next();
        				v2.add(new Integer(param));
        				ParametersIterator.remove();
        				System.out.println("Port:"+param);
        			}
        			else
        			{
  						v2.add(new Integer(161));
         				//se non e' un "-p" significa che e' terminato l'elenco dei targets ed iniziano
        				//le opzioni proprie dell'operazione
						ParametersIterator = args.iterator();
					}
				}
				else
				{
					//porta di default
					v2.add(new Integer(161));
					ParametersIterator = args.iterator();
				}
				if (ParametersIterator.hasNext())
					param = (String)ParametersIterator.next();
			}
			else
				v2.add(new Integer(161));
		}

		if (soma)
		{
			int j=0;
			places = new PlaceID[v1.size()];
			for(e1=v1.elements();e1.hasMoreElements();j++)
				places[j] = (PlaceID)e1.nextElement();
		}
		else//non soma
		{
			int j=0;
			hosts = new String[v1.size()];
			for(e1=v1.elements();e1.hasMoreElements();j++)
				hosts[j] = (String)e1.nextElement();
		}

		int j=0;
		ports = new int[v2.size()];
		for(e2=v2.elements();e2.hasMoreElements();j++)
			ports[j] = ((Integer)e2.nextElement()).intValue();

        //i parametri che rimangono nella Collection sono quelli corrispondenti alle variabili
        //static della classe Settings
        String[] rem = (String[])args.toArray(new String[0]);

        Settings sets = new Settings(debug,out);
        String[] extra = sets.parseArguments(rem,options,values,usage);
        //l'array di stringhe e' in questo caso la stringa che rappresenta l'HF
        //devo ricostruire un'unica stringa.. non tanto bello!!
        String HF = new String("");
        for (int i=0; i< extra.length; i++)
        	HF = HF+" "+extra[i];

		//il risultato sara' un array di Integer/Long se si calcola il valore semplice di un HF per ogni target
		//sara' un array di Hashtable (oid_row --> valore HF) se si calcola HF su una tabella per ogni target 
		result = new Object[Ntargets];
		
   		if (soma)
   			if (mobility)
   				result = snmpMHF(places,ports,HF,table);
   			else
   			{
   				Crono.Start();
   				if (table)
	       			result = manager.snmpHFTable(places,ports,values,HF);
	       		else
	       			result = manager.snmpHF(places,ports,values,HF);
        		Crono.Stop();
		       	System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
            }
       	else //host:port solo stazionario
       	{
			Crono.Start();
   			if (table)
	       		result = manager.snmpHFTable(hosts,ports,values,HF);
	       	else
	       		result = manager.snmpHF(hosts,ports,values,HF);
        	Crono.Stop();
		   	System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
        }
        
        if (table) 
        //array di Hashtable: 1 per ogni target e ognuna contenente le associazioni:
        //identificatore di una riga --> valore della HF per quella riga
        {
        	for (int x=0; x<result.length; x++)
        	{
        		if (soma)
        			out.println("Result from: ("+ places[x].toString()+":"+ports[x]+")");
        		else
        			out.println("Result from: ("+hosts[x]+":"+ports[x]+")");
        		Hashtable cur = (Hashtable)result[x];
        		for (Enumeration e = cur.keys(); e.hasMoreElements();)
        		{
        			Object rowid = (Object) e.nextElement();
        			Object rowval = (Object)cur.get(rowid);
        			out.println(rowid+": "+rowval);
        		}
        		out.println();
        	}
        }
        else  //array di Integer/Long: 1 solo valore di HF per ogni nodo target
           	for (int k=0; k<result.length; k++)
        	{
        		if (soma)
        			out.println("Result from: ("+ places[k].toString()+":"+ports[k]+")");
        		else
        			out.println("Result from: ("+hosts[k]+":"+ports[k]+")");
       			if (result[k] == null) 
    	    		out.println("HF value not retrieved");
        		else
            		out.println(result[k]);

            	out.println();
        	}

        return;

	}
	
   public void snmpMultiAtomicOp(int op,boolean soma, boolean mobility, Collection args)
   {
        Iterator ParametersIterator = args.iterator();
   		String nonrep = null;
   		String maxrep = null;
        String values[] = new String[Settings.NMAXOPTIONS];
        String[] hosts = null;
        PlaceID[] places = null;
        int[] ports = null;
        String[] oids = null;
        String extra[] = null;

        //deserializzo se non e' stato gia' fatto perche' per questo tipo di operazioni mi appoggio
        //sempre alla configurazione
        config.restoreConfiguration();

   		if (op == GETBULK)
   		{
            nonrep = (String)ParametersIterator.next();
        	ParametersIterator.remove();
            maxrep = (String)ParametersIterator.next();
        	ParametersIterator.remove();
            System.out.println("Nonrep: "+nonrep+" Maxrep: "+maxrep);
   		}

        String param = (String)ParametersIterator.next();
        //se c'e' subito un'opzione e' sbagliato, e' obbligatorio specificare
		//il target
		if ( param.charAt(0) == '-')
        {
            out.println(usage);
            return;
        }

        int Ntargets;
        try{
        	Ntargets = Integer.parseInt(param);
        	out.println(Ntargets);
        	ParametersIterator.remove();
           }
        catch(NumberFormatException e)
        {
           	out.println(usageMoreP);
        	return;
		}

		Vector v1 = new Vector();
		Vector v2 = new Vector();
		Enumeration e1;
		Enumeration e2;

		//preparo il prossimo parametro
		param = (String)ParametersIterator.next();

        //leggo i nomi dei targets (dom.+place)/IP hosts e le eventuali porte associate
       	//adesso dovrei avere almeno 1 nome place(di default)/1 host 1 OID e comunque non subito opzioni
       	if ((args.size() < 2) || (param.charAt(0) == '-'))
       	{
       		out.println(usageMoreP);
       		return;
       	}
       	else
       	for (int k=0; k<Ntargets; k++)
       	{
       		if (soma)
       		{
       			String dominio = param;
       			ParametersIterator.remove();
       			param = (String)ParametersIterator.next();

				//CORREGGERE: potrebbe trattarsi di un place di default --> solo 1 nome
				if (param.charAt(0) == '-')
				{
        			out.println(usageMoreP);
        			return;
        		}

        		String place = param;
        		ParametersIterator.remove();

        		v1.add(new PlaceID(dominio,place));
				System.out.println("Dominio: "+dominio+" Place: "+place);
			}
			else //non soma
			{
	        	v1.add(param);
				System.out.println("Host: "+param);
	        	ParametersIterator.remove();
	        }

	        if (args.size() >= 2)
	        {
				//controllo se e' stata specificata anche una porta
				param = (String)ParametersIterator.next();
				if (param.charAt(0) == '-')
				{
					if (param.equals("-p"))
					{
        				ParametersIterator.remove();
        				param = (String)ParametersIterator.next();
        				v2.add(new Integer(param));
        				ParametersIterator.remove();
        				System.out.println("Port:"+param);
        			}
        			else
        			{
  						v2.add(new Integer(161));
         				//se non e' un "-p" significa che e' terminato l'elenco dei targets ed iniziano
        				//le opzioni proprie dell'operazione
						ParametersIterator = args.iterator();
					}
				}
				else
				{
					//porta di default
					v2.add(new Integer(161));
					ParametersIterator = args.iterator();
				}
				if (ParametersIterator.hasNext())
					param = (String)ParametersIterator.next();
			}
			else
				v2.add(new Integer(161));
		}

		if (soma)
		{
			int j=0;
			places = new PlaceID[v1.size()];
			for(e1=v1.elements();e1.hasMoreElements();j++)
				places[j] = (PlaceID)e1.nextElement();
		}
		else//non soma
		{
			int j=0;
			hosts = new String[v1.size()];
			for(e1=v1.elements();e1.hasMoreElements();j++)
				hosts[j] = (String)e1.nextElement();
		}

		int j=0;
		ports = new int[v2.size()];
		for(e2=v2.elements();e2.hasMoreElements();j++)
			ports[j] = ((Integer)e2.nextElement()).intValue();

		//ora nella Collection rimangono tutti gli argomenti opzionali comuni non compresi
		//nella configurazione: contextid contextname timeout retries
       	String[] rem = (String[])args.toArray(new String[0]);

       	Settings sets = new Settings(debug,out);
       	oids = sets.parseArguments(rem,options,values,usage);
       	if ((oids == null)&&(op != WALK))
       	{
           	out.println(usage);
            return;
        }

        for (int k=0; k<values.length; k++)
            System.out.println(options[k]+": "+values[k]);

        for (int i=0; i< oids.length; i++)
            System.out.println(oids[i]);

        if (config.getNumericOIDs(oids) == false)
        {
        	out.println("Impossible to resolve all symbolic oids");
        	return;
        }
        SnmpPDU[] pdus = null;
        switch (op)
        {
            case GET:
            		if (soma)
            			if (mobility)
            			{
            				snmpMGet(places,ports,oids);
            				return;
            			}
            			else
            			{
            				Crono.Start();
            				pdus = manager.snmpGet(places,ports,values,oids);
        					Crono.Stop();
		       				System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
            			}
	            	else //host:port solo stazionario
	            	{
            			Crono.Start();
   			            pdus = manager.snmpGet(hosts,ports,values,oids);
        				Crono.Stop();
		       			System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
            		}
	        	    break;

            case GETNEXT:
        	   		if (soma)
        	   			if (mobility)
        	   			{
        	   				snmpMGetNext(places,ports,oids);
        	   				return;
        	   			}
        	   			else
        	   			{
        	   				Crono.Start();
   			   				pdus = manager.snmpGetNext(places,ports,values,oids);
        					Crono.Stop();
		       				System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
            			}
        	   		else //host:port solo stazionario
        	   		{
        	   			Crono.Start();
        	   			pdus = manager.snmpGetNext(hosts,ports,values,oids);
        				Crono.Stop();
		       			System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
            		}
                	break;

            case GETBULK:
            		if (soma)
            			if (mobility)
            			{
            				snmpMGetBulk(places,ports,oids,nonrep,maxrep);
            				return;
            			}
            			else
            			{
            				Crono.Start();
   			   				pdus = manager.snmpGetBulk(places,ports,values,oids,nonrep,maxrep);
        					Crono.Stop();
		       				System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
            			}
            		else //host:port solo stazionario
            		{
            			Crono.Start();
    	        		pdus = manager.snmpGetBulk(hosts,ports,values,oids,nonrep,maxrep);
       					Crono.Stop();
	       				System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
           			}
	           		break;

            case MINMAXAVE:
            		InfoDomain info = null;
                    if (soma)
                    	if (mobility)
                    	{
                    		info = snmpMinMaxAve(places,ports,oids);
                    		return;
                    	}
                    	else
                    	{
            				Crono.Start();
                    		info = manager.getInfoOnDomain(places,ports,values,oids);
	       					Crono.Stop();
		       				System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
        	   			}
                    else
                    {
            			Crono.Start();
                    	info = manager.getInfoOnDomain(hosts,ports,values,oids);
	       				Crono.Stop();
		       			System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
        	   		}
                    //QUI DEVO INSERIRE la stampa della struttura DomainInfo
                    outInfoDomain(oids,info);
                    return;

            default:
                	return;
        }
        
        //questa parte viene eseguita solo per GET/GETNEXT/GETBULK: 1 pdu per ogni target
        if  (pdus == null)
        {
            out.println("No result returned");
            return;
        }

        for (int k=0; k<pdus.length; k++)
        {
        	if (soma)
        		out.println("Result from: ("+ places[k].toString()+":"+ports[k]+")");
        	else
        		out.println("Result from: ("+hosts[k]+":"+ports[k]+")");
       		if ((pdus[k] != null) && (pdus[k].getErrstat() != 0))
    	    {
    	    	out.println("Errore sulla richiesta");
    	        out.println(pdus[k].getError());
    	    }
        	else
            	config.outPDU(pdus[k]);

            out.println();
        }

        return;

   }

   //Dispatcher di operazioni GET/GETNEXT/GETBULK/MINMAXAVE su domini, 
   //cioe' su tutti i place appartenenti ai domini precisati
   //N.B. da completare.. fatta solo GET e solo caso di mobilita' 
   public void snmpDomainAtomicOp(int op, boolean mobility, Collection args)
   {
        Iterator ParametersIterator = args.iterator();
   		String nonrep = null;
   		String maxrep = null;
        String values[] = new String[Settings.NMAXOPTIONS];
        PlaceID[] domains = null;
        String[] oids = null;
        String extra[] = null;

        //deserializzo se non e' stato gia' fatto perche' per questo tipo di operazioni mi appoggio
        //sempre alla configurazione
        config.restoreConfiguration();

   		if (op == GETBULK)
   		{
            nonrep = (String)ParametersIterator.next();
        	ParametersIterator.remove();
            maxrep = (String)ParametersIterator.next();
        	ParametersIterator.remove();
            System.out.println("Nonrep: "+nonrep+" Maxrep: "+maxrep);
   		}

        String param = (String)ParametersIterator.next();
        //se c'e' subito un'opzione e' sbagliato, e' obbligatorio specificare
		//il target
		if ( param.charAt(0) == '-')
        {
            out.println(usage);
            return;
        }

        int Ntargets;
        try{
        	Ntargets = Integer.parseInt(param);
        	out.println(Ntargets);
        	ParametersIterator.remove();
           }
        catch(NumberFormatException e)
        {
           	out.println(usageMoreP);
        	return;
		}

		Vector v1 = new Vector();
		Enumeration e1;

		//preparo il prossimo parametro
		param = (String)ParametersIterator.next();

        //leggo i nomi dei targets domini
       	if ((args.size() < 2) || (param.charAt(0) == '-'))
       	{
       		out.println(usageMoreP);
       		return;
       	}
       	else
       	for (int k=0; k<Ntargets; k++)
       	{
       		String dominio = param;
       		ParametersIterator.remove();
       		param = (String)ParametersIterator.next();

        	v1.add(new PlaceID(dominio,null));
			System.out.println("Dominio: "+dominio);
		}

		int j=0;
		domains = new PlaceID[v1.size()];
		for(e1=v1.elements();e1.hasMoreElements();j++)
				domains[j] = (PlaceID)e1.nextElement();
				
		//ora nella Collection rimangono tutti gli argomenti opzionali comuni non compresi
		//nella configurazione: contextid contextname timeout retries
       	String[] rem = (String[])args.toArray(new String[0]);

       	Settings sets = new Settings(debug,out);
       	oids = sets.parseArguments(rem,options,values,usage);
       	if ((oids == null)&&(op != WALK))
       	{
           	out.println(usage);
            return;
        }

        for (int k=0; k<values.length; k++)
            System.out.println(options[k]+": "+values[k]);

        for (int i=0; i< oids.length; i++)
            System.out.println(oids[i]);

        if (config.getNumericOIDs(oids) == false)
        {
        	out.println("Impossible to resolve all symbolic oids");
        	return;
        }
        SnmpPDU[] pdus = null;
        switch (op)
        {
            case GET:
           			if (mobility)
           			{
           				snmpDGet(domains, oids);
           				return;
           			}
           			//else
            		//	pdus = manager.snmpGet(places,ports,values,oids);
	        	    break;

           
            default:
                	return;
        }

        return;
   }

   public void tableOp(boolean filter,boolean soma, boolean conf, boolean mobility, Collection args)
   {
        Iterator ParametersIterator = args.iterator();

        String values[] = new String[Settings.NMAXOPTIONS];
        String[] oids = null;
        String host = null;
        PlaceID placeID = null;
        String inf = null,
               cinf = null,
               col = null,
               csup = null,
               sup = null;

        if (filter)
        {
            inf = (String)ParametersIterator.next();
        	ParametersIterator.remove();
            cinf = (String)ParametersIterator.next();
        	ParametersIterator.remove();
            col = (String)ParametersIterator.next();
        	ParametersIterator.remove();
            csup = (String)ParametersIterator.next();
        	ParametersIterator.remove();
            sup = (String)ParametersIterator.next();
        	ParametersIterator.remove();
            out.println("Condition: "+inf+" "+cinf+" "+col+" "+csup+" "+sup);
        }

        String param = (String)ParametersIterator.next();
        //se c'e' subito un'opzione e' sbagliato, e' obbligatorio specificare
		//il target
		if ( param.charAt(0) == '-')
        {
            out.println(usage);
            return;
        }
		//se si usa il naming di soma si avra' il nome di dominio ed il nome del place
		if (soma)
		{
			//recupero nome di dominio
			String dominio = param;
			ParametersIterator.remove();
			//recupero nome di place
			String place = (String)ParametersIterator.next();
			ParametersIterator.remove();
			placeID = new PlaceID(dominio,place);
			System.out.println("Dominio: "+dominio+" Place: "+place);
		}
		else
		{
			//recupero IP host
			host = param;
			ParametersIterator.remove();
			System.out.println("Host: "+host);
	    }

        //nella Collection rimangono tutte le opzioni associate alle var. static della classe Settings
        String[] rem = (String[])args.toArray(new String[0]);

        Settings sets = new Settings(debug,out);
        oids = sets.parseArguments(rem,options,values,usage);
        int port = 161;
        if (values[Settings.PORT] != null)
        	port = Integer.parseInt(values[Settings.PORT]);

        if (oids == null)
        {
            out.println(usage);
            return;
        }

        System.out.println("Port: "+port);
        for (int k=0; k<values.length; k++)
            out.println(options[k]+": "+values[k]);

        String[] OIDs = null;

        if (filter)
        {
        	//inserisco in unico array i due OID per convertirli in numerici con una sola chiamata
        	OIDs = new String[2];
        	//oid tabella
        	OIDs[0] = oids[0];
        	//oid colonna
        	OIDs[1] = col;
        }
        else
        {
        	OIDs = new String[1];
        	OIDs[0] = oids[0];
        }

        if (soma)
	    	    config.getNumericOIDs(placeID,port,OIDs);
        else
    	    	config.getNumericOIDs(host,port,OIDs);

        SnmpPDU pdu = new SnmpPDU();

        if (filter)
        {
                snmpTable tabf = null;
                if (soma)
                	if (mobility)
	            	{
	            		PlaceID[] places = new PlaceID[1];
	            		places[0] = placeID;
	            		int[] ports = new int[1];
	            		ports[0] = port;
	            		getMFiltering(places,ports,OIDs[0],inf+" "+cinf+" "+OIDs[1]+" "+csup+" "+sup);
	            		return;
	            	}
	            	else
	            	{
						Crono.Start();	            	
	                	tabf = manager.FilterTable(placeID,values,OIDs[0],inf,cinf,OIDs[1],csup,sup,conf);
       					Crono.Stop();
	       				System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
       	   			}
                else
                {
					Crono.Start();                
                	tabf = manager.FilterTable(host,values,OIDs[0],inf,cinf,OIDs[1],csup,sup,conf);
   					Crono.Stop();
       				System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
   	   			}

                config.printTable(new sharedOut(out),tabf);
 		}
        else
        {
            	snmpTable tab = null;
            	if (soma)
            		if (mobility)
	            	{
	            		PlaceID[] places = new PlaceID[1];
	            		places[0] = placeID;
	            		int[] ports = new int[1];
	            		ports[0] = port;
	            		getMTable(places,ports,OIDs[0]);
	            		return;
	            	}
	            	else
	            	{
	            		Crono.Start();
	            		tab = manager.getTable(placeID,values,OIDs[0],conf);
       					Crono.Stop();
	       				System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
       	   			}
    			else
    			{
    				Crono.Start();
    	           	tab = manager.getTable(host,values,OIDs[0],conf);
   					Crono.Stop();
       				System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
   	   			}
                config.printTable(new sharedOut(out),tab);
		}
        return;

   }

   void MultitableOp(boolean filter,boolean soma, boolean mobility, Collection args)
   {
        Iterator ParametersIterator = args.iterator();

        String values[] = new String[Settings.NMAXOPTIONS];
        String[] hosts = null;
        PlaceID[] places = null;
        int[] ports = null;
        String[] oids = null;
        String inf = null,
               cinf = null,
               col = null,
               csup = null,
               sup = null;

        if (filter)
        {
            inf = (String)ParametersIterator.next();
        	ParametersIterator.remove();
            cinf = (String)ParametersIterator.next();
        	ParametersIterator.remove();
            col = (String)ParametersIterator.next();
        	ParametersIterator.remove();
            csup = (String)ParametersIterator.next();
        	ParametersIterator.remove();
            sup = (String)ParametersIterator.next();
        	ParametersIterator.remove();
            out.println("Condition: "+inf+" "+cinf+" "+col+" "+csup+" "+sup);
        }

        //deserializzo se non e' stato gia' fatto perche' per questo tipo di operazioni mi appoggio
        //sempre alla configurazione
        config.restoreConfiguration();

        String param = (String)ParametersIterator.next();
        //se c'e' subito un'opzione e' sbagliato, e' obbligatorio specificare
		//il target
		if ( param.charAt(0) == '-')
        {
            out.println(usage);
            return;
        }

        int Ntargets;
        try{
        	Ntargets = Integer.parseInt(param);
        	ParametersIterator.remove();
        	}
        catch(NumberFormatException e)
        {
           	out.println(usageMoreP);
        	return;
		}

		Vector v1 = new Vector();
		Vector v2 = new Vector();
		Enumeration e1;
		Enumeration e2;

		param = (String)ParametersIterator.next();

        //leggo i nomi dei targets (dom.+place)/IP hosts e le eventuali porte associate
       	//adesso dovrei avere almeno 1 nome place(di default)/1 host 1 OID e comunque non subito opzioni
       	if ((args.size() < 2) || (param.charAt(0) == '-'))
       	{
       		out.println(usageMoreP);
       		return;
       	}
       	else
       	for (int k=0; k<Ntargets; k++)
       	{
       		if (soma)
       		{
       			String dominio = param;
       			ParametersIterator.remove();
       			param = (String)ParametersIterator.next();

				//CORREGGERE: potrebbe trattarsi di un place di default --> solo 1 nome
				if (param.charAt(0) == '-')
				{
        			out.println(usageMoreP);
        			return;
        		}

        		String place = param;
        		ParametersIterator.remove();

        		v1.add(new PlaceID(dominio,place));
				System.out.println("Dominio: "+dominio+" Place: "+place);
			}
			else //non soma
			{
	        	v1.add(param);
	        	ParametersIterator.remove();
	        }

	        if (args.size() >= 2)
	        {
				//controllo se e' stata specificata anche una porta
				param = (String)ParametersIterator.next();
				if (param.charAt(0) == '-')
				{
					if (param.equals("-p"))
					{
        				ParametersIterator.remove();
        				param = (String)ParametersIterator.next();
        				v2.add(new Integer(param));
        				ParametersIterator.remove();
        			}
        			else
        			{
						v2.add(new Integer(161));
	        			ParametersIterator = args.iterator();
	        		}
				}
				else
				{
					//porta di default
					v2.add(new Integer(161));
					ParametersIterator = args.iterator();
				}
			}
			else
				v2.add(new Integer(161));
			if (ParametersIterator.hasNext())
				//preparo param per prossimo ciclo
				param = (String)ParametersIterator.next();
		}

		if (soma)
		{
			int j=0;
			places = new PlaceID[v1.size()];
			for(e1=v1.elements();e1.hasMoreElements();j++)
				places[j] = (PlaceID)e1.nextElement();
		}
		else//non soma
		{
			int j=0;
			hosts = new String[v1.size()];
			for(e1=v1.elements();e1.hasMoreElements();j++)
				hosts[j] = (String)e1.nextElement();
		}

		int j=0;
		ports = new int[v2.size()];
		for(e2=v2.elements();e2.hasMoreElements();j++)
			ports[j] = ((Integer)e2.nextElement()).intValue();

		//ora nella Collection rimangono tutti gli argomenti opzionali comuni non compresi
		//nella configurazione: contextid contextname timeout retries
        String[] rem = (String[])args.toArray(new String[0]);

        Settings sets = new Settings(debug,out);
        oids = sets.parseArguments(rem,options,values,usage);

        if (oids == null)
        {
            out.println(usage);
            return;
        }

        for (int k=0; k<values.length; k++)
            System.out.println(options[k]+": "+values[k]);


        String[] OIDs = null;

        if (filter)
        {
        	//inserisco in unico array i due OID per convertirli in numerici con una sola chiamata
        	OIDs = new String[2];
        	//oid tabella
        	OIDs[0] = oids[0];
        	//oid colonna
        	OIDs[1] = col;
        }
        else
        {
        	OIDs = new String[1];
        	OIDs[0] = oids[0];
        }

   	    if (config.getNumericOIDs(OIDs) == false)
   	    	return;

   	    if (filter) //filtraggio tabelle
   	    {
   	    	snmpTable[] tabf = null;
   	    	if (soma) //naming SOMA
   	    	{
   	    		if (mobility) //con uso di MA
   	    		{
            		getMFiltering(places,ports,OIDs[0],inf+" "+cinf+" "+OIDs[1]+" "+csup+" "+sup);
   	    			return;
   	    		}
   	    		else  //C/S
   	    		{
   	    			Crono.Start();
   			for (int x=0; x<places.length; x++)
   			{
   				out.println("[Worker: [Agent: d d18 8 not traceable] Status: ON] calling method: public void MobileMonitoring.SnmpV3MobileManager.prepareLocalJob()");
                out.println("Worker [Worker: [Agent: d d18 8 not traceable] Status: ON]: agent [Agent: d d18 8 not traceable] sent to d d18");
   			}
                	tabf = manager.FilterTable(places,ports,values,OIDs[0],inf,cinf,OIDs[1],csup,sup);
  					Crono.Stop();
       				System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
                	if (tabf == null)
                		return;
            		for (int k=0; k<tabf.length; k++)
            			config.printTable(new sharedOut(out),tabf[k]);
               		return;
                }
            }
            else  //con host:port puo' solo essere stazionario
            {
            		Crono.Start();
            		tabf = manager.FilterTable(hosts,ports,values,OIDs[0],inf,cinf,OIDs[1],csup,sup);
  					Crono.Stop();
       				System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
            		if (tabf == null)
            			return;
            		for (int k=0; k<tabf.length; k++)
            		{
            			out.println("Table rows from: ("+hosts[k]+":"+ports[k]+")");
            			config.printTable(new sharedOut(out),tabf[k]);
            			out.println();
            		}
            		return;
            }
       }
       else //recupero tabelle
       {
       		snmpTable[] tab = null;
       		if (soma)   //con naming SOMA
       		{
       			if (mobility)   //con uso di MA
       			{
       				getMTable(places,ports,OIDs[0]);
       				return;
       			}
       			else   //C/S
       			{
       				Crono.Start();
       			 	tab = manager.getTable(places,ports,values,OIDs[0]);
  					Crono.Stop();
       				System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
            		for (int k=0; k<tab.length; k++)
            			config.printTable(new sharedOut(out),tab[k]);
                	return;
                }
            }
            else   //con host:port puo' solo essere stazionario
            {
            		Crono.Start();
					tab = manager.getTable(hosts,ports,values,OIDs[0]);
  					Crono.Stop();
       				System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
            		out.println(tab.length);
            		for (int k=0; k<tab.length; k++)
            		{
            			out.println("Table from: ("+hosts[k]+":"+ports[k]+")");
            			config.printTable(new sharedOut(out),tab[k]);
            			out.println();
            		}
                	return;
            }
		}

	}

   void Polling(boolean soma, boolean conf, boolean mobility, Collection args)
   {
        String values[] = new String[Settings.NMAXOPTIONS];
        String[] oids = null;
        String host = null;
        PlaceID placeID = null;
        int type=0;
        int gap=0;
        int total=0;
        String extra[] = null;

        Iterator ParametersIterator = args.iterator();
  		if (args.size() < 5)
        {
            if (soma)
            	out.println(usagePollerP);
            else
	            out.println(usagePoller);
            return;
        }

		//recupero tipo di operazione richiesta
        type = Integer.parseInt((String)ParametersIterator.next());
        ParametersIterator.remove();

        if ((type != GET) && (type != GETNEXT) && (type != GETBULK) &&
            (type != GETABLE) && (type != FILTERT) && (type != HF) && (type != HFTABLE))
        {
            out.println("Operation not available for polling");
            return;
        }

        //recupero intervallo di polling
        gap = Integer.parseInt((String)ParametersIterator.next());
		ParametersIterator.remove();

		//recupero intervallo di osservazione
		total = Integer.parseInt((String)ParametersIterator.next());
		ParametersIterator.remove();
        out.println("Polling interval: "+gap+"  Observation interval: "+total);

        if (type == GETBULK)
        {
            extra = new String[2];
            //non_rep
            extra[0] = (String)ParametersIterator.next();
			ParametersIterator.remove();
			//max_rep
	        extra[1] = (String)ParametersIterator.next();
			ParametersIterator.remove();
        }
        else if (type == FILTERT)
        {
            extra = new String[5];
            //rif_inf
            extra[0] = (String)ParametersIterator.next();
			ParametersIterator.remove();
			//cond_inf
            extra[1] = (String)ParametersIterator.next();
			ParametersIterator.remove();
			//col
            extra[2] = (String)ParametersIterator.next();
			ParametersIterator.remove();
			//cond_sup
            extra[3] = (String)ParametersIterator.next();
			ParametersIterator.remove();
			//rif_sup
            extra[4] = (String)ParametersIterator.next();
			ParametersIterator.remove();
        }
		String param = (String)ParametersIterator.next();

        //se c'e' subito un'opzione e' sbagliato, e' obbligatorio specificare
		//il target
		if ( param.charAt(0) == '-')
        {
            out.println(usage);
            return;
        }

		//se si usa il naming di soma si avra' il nome di dominio ed il nome del place
		if (soma)
		{
			//recupero nome di dominio
			String dominio = param;
			ParametersIterator.remove();
			//recupero nome di place
			String place = (String)ParametersIterator.next();
			ParametersIterator.remove();
			placeID = new PlaceID(dominio,place);
			System.out.println("Dominio: "+dominio+" Place: "+place);
		}
		else
		{
			//recupero IP di host
			host = param;
			ParametersIterator.remove();
			System.out.println("Host: "+host);
	    }

        //rem e' destinato a contenere tutte le opzioni che rimangono sulla linea di comando
        String[] rem = (String[])args.toArray(new String[0]);

        Settings sets = new Settings(debug,out);
        oids = sets.parseArguments(rem,options,values,usage);
        
        if ((type == HF) || (type == HFTABLE))
        {
            extra = new String[1];
            //recupero la HF   
            String HF = new String("");
        	for (int i=0; i< oids.length; i++)
        		HF = HF+" "+oids[i];
            extra[0] = HF;
		}
		
        int port = 161;
        if (values[Settings.PORT] != null)
        	port = Integer.parseInt(values[Settings.PORT]);

        if (oids == null)
        {
            out.println(usage);
            return;
        }

        out.println("Port: "+port);
        for (int k=0; k<values.length; k++)
            System.out.println(options[k]+": "+values[k]);

        if (soma)
    	    config.getNumericOIDs(placeID,port,oids);
    	else
   	    	config.getNumericOIDs(host,port,oids);

		//se si tratta di filtraggio devo anche convertire l'eventuale
		//oid simbolico relativo alla colonna
       	if (type == FILTERT)
       	{
       		String[] toconv = new String[1];
       		toconv[0] = extra[2];
            config.getNumericOIDs(host,port,toconv);
            extra[2] = toconv[0];
        }

		Vector polls = new Vector();
		if (soma)
			if (mobility)
			{
    			PlaceID[] places = new PlaceID[1];
    			places[0] = placeID;
    			int[] ports = new int[1];
    			ports[0] = port;
				MobilePolling(places,ports,extra,oids,type,total,gap);
			}
			else
			{
				Crono.Start();
	        	polls = manager.snmpPoller(placeID,values,extra,oids,type,total,gap,conf);
	        	outPolls(polls,type,oids);
				Crono.Stop();
   				System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
   			}
        else
        {
        	Crono.Start();
        	polls = manager.snmpPoller(host,values,extra,oids,type,total,gap,conf);
        	outPolls(polls,type,oids);
  			Crono.Stop();
       		System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
       	}
       	
        return;
   }
   
   public void MultiPolling(boolean soma, boolean mobility, Collection args)
   {
   		int total=0;
   		int poll=0;
   		int type=0;
        String extra[] = null;
        String[] hosts = null;
        PlaceID[] places = null;
        int[] ports = null;
        String values[] = new String[Settings.NMAXOPTIONS];
        String[] oids = null;
        
        Iterator ParametersIterator = args.iterator();
   		type = (new Integer((String)ParametersIterator.next())).intValue();
       	ParametersIterator.remove();

        if ((type != GET) && (type != GETNEXT) && (type != GETBULK) &&
            (type != GETABLE) && (type != FILTERT) && (type != HF) && (type != HFTABLE))
        {
            out.println("Operation not available for polling");
            return;
        }
        
        poll= (new Integer((String)ParametersIterator.next())).intValue();
       	ParametersIterator.remove();
        total = (new Integer((String)ParametersIterator.next())).intValue();
      	ParametersIterator.remove();

        out.println("Polling interval: "+poll+"  Observation interval: "+total);

        if (type == GETBULK)
        {
            extra = new String[2];
            //non_rep
            extra[0] = (String)ParametersIterator.next();
			ParametersIterator.remove();
			//max_rep
	        extra[1] = (String)ParametersIterator.next();
			ParametersIterator.remove();
        }
        else if (type == FILTERT)
        {
            extra = new String[5];
            //rif_inf
            extra[0] = (String)ParametersIterator.next();
			ParametersIterator.remove();
			//cond_inf
            extra[1] = (String)ParametersIterator.next();
			ParametersIterator.remove();
			//col
            extra[2] = (String)ParametersIterator.next();
			ParametersIterator.remove();
			//cond_sup
            extra[3] = (String)ParametersIterator.next();
			ParametersIterator.remove();
			//rif_sup
            extra[4] = (String)ParametersIterator.next();
			ParametersIterator.remove();
        }
        //deserializzo se non e' stato gia' fatto perche' per questo tipo di operazioni mi appoggio
        //sempre alla configurazione
        config.restoreConfiguration();

        String param = (String)ParametersIterator.next();
        
        //se c'e' subito un'opzione e' sbagliato, e' obbligatorio specificare
		//il target
		if ( param.charAt(0) == '-')
        {
            out.println(usage);
            return;
        }

        int Ntargets;
        try{
        	Ntargets = Integer.parseInt(param);
        	ParametersIterator.remove();
        	}
        catch(NumberFormatException e)
        {
           	out.println(usageMoreP);
        	return;
		}

		Vector v1 = new Vector();
		Vector v2 = new Vector();
		Enumeration e1;
		Enumeration e2;

		param = (String)ParametersIterator.next();

        //leggo i nomi dei targets (dom.+place)/IP hosts e le eventuali porte associate
       	//adesso dovrei avere almeno 1 nome place(di default)/1 host 1 OID e comunque non subito opzioni
       	if ((args.size() < 2) || (param.charAt(0) == '-'))
       	{
       		out.println(usageMoreP);
       		return;
       	}
       	else
       	for (int k=0; k<Ntargets; k++)
       	{
       		if (soma)
       		{
       			String dominio = param;
       			ParametersIterator.remove();
       			param = (String)ParametersIterator.next();

				//CORREGGERE: potrebbe trattarsi di un place di default --> solo 1 nome
				if (param.charAt(0) == '-')
				{
        			out.println(usageMoreP);
        			return;
        		}

        		String place = param;
        		ParametersIterator.remove();

        		v1.add(new PlaceID(dominio,place));
				System.out.println("Dominio: "+dominio+" Place: "+place);
			}
			else //non soma
			{
	        	v1.add(param);
	        	ParametersIterator.remove();
	        }

	        if (args.size() >= 2)
	        {
				//controllo se e' stata specificata anche una porta
				param = (String)ParametersIterator.next();
				if (param.charAt(0) == '-')
				{
					if (param.equals("-p"))
					{
        				ParametersIterator.remove();
        				param = (String)ParametersIterator.next();
        				v2.add(new Integer(param));
        				ParametersIterator.remove();
        			}
        			else
        			{
						v2.add(new Integer(161));
	        			ParametersIterator = args.iterator();
	        		}
				}
				else
				{
					//porta di default
					v2.add(new Integer(161));
					ParametersIterator = args.iterator();
				}
			}
			else
				v2.add(new Integer(161));
			if (ParametersIterator.hasNext())
				//preparo param per prossimo ciclo
				param = (String)ParametersIterator.next();
		}

		if (soma)
		{
			int j=0;
			places = new PlaceID[v1.size()];
			for(e1=v1.elements();e1.hasMoreElements();j++)
				places[j] = (PlaceID)e1.nextElement();
		}
		else//non soma
		{
			int j=0;
			hosts = new String[v1.size()];
			for(e1=v1.elements();e1.hasMoreElements();j++)
				hosts[j] = (String)e1.nextElement();
		}

		int j=0;
		ports = new int[v2.size()];
		for(e2=v2.elements();e2.hasMoreElements();j++)
			ports[j] = ((Integer)e2.nextElement()).intValue();

		//ora nella Collection rimangono tutti gli argomenti opzionali comuni non compresi
		//nella configurazione: contextid contextname timeout retries
        String[] rem = (String[])args.toArray(new String[0]);

        Settings sets = new Settings(debug,out);
        oids = sets.parseArguments(rem,options,values,usage);


        if ((type == HF) || (type == HFTABLE))
        {
            extra = new String[1];
            //recupero la HF   
            String HF = new String("");
        	for (int i=0; i< oids.length; i++)
        		HF = HF+" "+oids[i];
            extra[0] = HF;
		}
		else
		{
        if (oids == null)
        {
            out.println(usage);
            return;
        }
        
        if (config.getNumericOIDs(oids) == false)
        {
        	out.println("Impossible to resolve all symbolic oids");
        	return;
        }
		}
		//se si tratta di filtraggio devo anche convertire l'eventuale
		//oid simbolico relativo alla colonna
       	if (type == FILTERT)
       	{
       		String[] toconv = new String[1];
       		toconv[0] = extra[2];
            config.getNumericOIDs(toconv);
            extra[2] = toconv[0];
        }

		Vector polls = new Vector();
		if (soma)
			if (mobility)
			{
			out.println("OK");
     		MobilePolling(places,ports,extra,oids,type,total,poll);
			}
			else
			{
				Crono.Start();
	        	polls = manager.snmpPoller(places,ports,values,extra,oids,type,total,poll);
	        	outMultiPolls(places,polls,type,oids);
				Crono.Stop();
   				System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
   			}
        else
        {
        	Crono.Start();
        	polls = manager.snmpPoller(hosts,ports,values,extra,oids,type,total,poll);
        	outMultiPolls(hosts,polls,type,oids);
  			Crono.Stop();
       		System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
       	}
       	
        return;
   }
   
   
   
   

//N.B type mi dovrebbe solo servire per sapere che agente mobile attivare=>posso togliere il tipo di op. da InfoPolling
    void MobilePolling(PlaceID[] places,int[] ports,String[] extra,String[] oids,int type,int total,int gap)
    {
		InfoPolling info;
    	byte optype;
    	
    	if ((type == GET)||(type == GETNEXT)||(type == GETBULK))
    	{
    	  if (type == GET)
      	    optype = SnmpAPI.GET_REQ_MSG;
    	  else if (type == GETNEXT)
    	      optype = SnmpAPI.GETNEXT_REQ_MSG;
    	  else
    	      optype = SnmpAPI.GETBULK_REQ_MSG;

    	  InfoAtomicSnmpOp subinfo = prepareAtomicInfo(optype,places,ports,oids,extra);
    	  info = new InfoPolling(total,gap,type,subinfo);
		    if (info == null)
			    return ;
			
		    AtomicPolling(info,oids);
		    return;
		 }

	   else if (type == GETABLE)
		 {
		   InfoTable subtable = prepareTableInfo(places,ports,oids[0]);
	   	  info = new InfoPolling(total,gap,type,subtable);
		   if (info == null)
		 	  return ;
		 }
		 else if (type == FILTERT)
		 {
		   String condition = extra[0]+" "+extra[1]+" "+extra[2]+" "+extra[3]+" "+extra[4];
       System.out.println(condition);
		 	InfoFiltering subfilter = prepareFiltering(places,ports,oids[0],condition);
	   	info = new InfoPolling(total,gap,type,subfilter);
		 	if (info == null)
		 	  return ;
		 }
		else if ((type == HF) || (type == HFTABLE))
		{
			String[] res = manager.parseHF(extra[0]);
			if (res == null)
  				return ;

  		 	String hf = res[res.length-1];
      System.out.println(hf);
  		 	String oid[] = new String[res.length-1];
  		 	for (int i=0; i<res.length-1; i++)
      {
  		 		oid[i] = res[i];
          out.println(oid[i]);
      }

  			InfoAtomicSnmpOp ihf = prepareAtomicInfo(SnmpAPI.GET_REQ_MSG,places,ports,oid,null);
			InfoHF subHF = null;
  			//se devo calcolare i valori di HF per ogni riga di una tabella avro' degli OID di tabella
  			//es. ifSpeed --> .1.3.6.1.2.1.2.2.1.5 , da cui l'identific. di riga --> .1.3.6.1.2.1.2.2.1.1
  			//e' il primo oggetto di una riga
  			if (type == HFTABLE)
  			{
  				String row = oid[0].substring(0,oid[0].length()-1)+"1";
  				subHF = new InfoHF(ihf,hf,row);
  			}
  			else
  				subHF = new InfoHF(ihf,hf);
		
			if (subHF == null)
				return ;
	    	info = new InfoPolling(total,gap,type,subHF);
			if (info == null)
				return ;
        boolean tab = false;
        if (type == HFTABLE)
          tab = true;
        HFPolling(info,hf,tab);
		}
		
	}
		
	public void AtomicPolling(InfoPolling info, String[] oids)
	{
		Crono.Start();

   		//creo ed attivo l'agente mobile delegato opportuno
   		String agentName = "MobileMonitoring.PollerAtomicOpMA";
   		AgentWorker worker =
           env.agentManager.createAgent(agentName,info,systemloader,traceable);
    	if( worker == null )
        	out.println( "ERROR: can't create agent." );
    	else
    	{
    		out.println(Header+" STARTING DELEGATED AGENT "+agentName);
        	try
         	{
            	worker.start();
         	}
            catch( Exception e )
            {
            	e.printStackTrace( out );
            }
            out.println( "Worker: " + worker + " CREATED AND STARTED." );
    	}
   		out.println(Header+" MI BLOCCO IN ATTESA DEL MESSAGGIO DI RISPOSTA");
		//chiamata sospensiva, dovrebbe sbloccarsi solo quando arriva la risposta dall'agente delegato
		Message answer = mailbox.getMessage();
		Crono.Stop();
		System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
		out.println(Header+" MESSAGGIO RICEVUTO");
		//una volta ricevuto il messaggio di risposta puo' visualizzare tutte le informazioni
		//la risposta contiene un vettore di Snmpvar[] (un elemento per ogni polling fatto) per ogni target
		Vector temp = (Vector)answer.message;

		int j=0;
		for (Enumeration e=temp.elements(); e.hasMoreElements();)
			for (Enumeration e1= ((Vector)e.nextElement()).elements(); e1.hasMoreElements();j++)
			{
				out.println("Polling #"+j);
				SnmpVar[] ris = (SnmpVar[])e1.nextElement();
				config.outPDU(oids,ris);
			}

	}

  	public void HFPolling(InfoPolling info, String hf,boolean tab)
	{
		Crono.Start();

   		//creo ed attivo l'agente mobile delegato opportuno
   		String agentName = "MobileMonitoring.PollerHFMA";
   		AgentWorker worker =
           env.agentManager.createAgent(agentName,info,systemloader,traceable);
    	if( worker == null )
        	out.println( "ERROR: can't create agent." );
    	else
    	{
    		out.println(Header+" STARTING DELEGATED AGENT "+agentName);
        	try
         	{
            	worker.start();
         	}
            catch( Exception e )
            {
            	e.printStackTrace( out );
            }
            out.println( "Worker: " + worker + " CREATED AND STARTED." );
    	}
   		out.println(Header+" MI BLOCCO IN ATTESA DEL MESSAGGIO DI RISPOSTA");
		//chiamata sospensiva, dovrebbe sbloccarsi solo quando arriva la risposta dall'agente delegato
		Message answer = mailbox.getMessage();
		Crono.Stop();
		System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
		out.println(Header+" MESSAGGIO RICEVUTO");
		//una volta ricevuto il messaggio di risposta puo' visualizzare tutte le informazioni
		//la risposta contiene un vettore di Object[] (un elemento per ogni polling fatto) per ogni target
    //opure un vettore di Hashtable[] se hf su tabella
		Vector temp = (Vector)answer.message;

		int j=0;
    if (tab) //ogni polling produce un hashtable e si ha il polling per piu nodi
    {
      for (Enumeration e = temp.elements(); e.hasMoreElements();)
 			for (Enumeration e1= ((Vector)e.nextElement()).elements(); e1.hasMoreElements();)
      {
			      Hashtable cur = (Hashtable)e1.nextElement();
        		for (Enumeration e2 = cur.keys(); e2.hasMoreElements();)
        		{
        			Object rowid = (Object) e2.nextElement();
        			Object rowval = (Object)cur.get(rowid);
        			out.println(rowid+": "+rowval);
        		}
        		out.println();
      }
      
    }
    else   //ogni polling da' un vettore di oggetti
    {
    for (Enumeration e = temp.elements(); e.hasMoreElements();)
			for (Enumeration e1= ((Vector)e.nextElement()).elements(); e1.hasMoreElements();j++)
			{
				out.println("Polling #"+j);
				out.println("HF value: "+(Object)e1.nextElement());
			}
    }
	}


	//stampa il Vector risultante da un polling su 1 solo target in modo coerente con il tipo di operazione ripetuta
	void outPolls(Vector polls, int op, String[] oids)
	{
		for (Enumeration e = polls.elements(); e.hasMoreElements(); )
		if ((op == GET) || (op == GETNEXT) || (op == GETBULK))
		{
			SnmpPDU pdu = (SnmpPDU)e.nextElement();
       		if  (pdu == null)
        	{
            	out.println("No result returned");
            	return;
        	}

       		if ((pdu != null) && (pdu.getErrstat() != 0))
    	    {
    	    	out.println("Errore sulla richiesta");
    	        out.println(pdu.getError());
    	    }
        	else
            	config.outPDU(pdu);
        }
		else if ((op == GETABLE) || (op == FILTERT))
       			config.printTable(new sharedOut(out),(snmpTable)e.nextElement());
		else if (op == HF)	
				out.println(e.nextElement());
		else if (op == HFTABLE)
		{
        	out.println("Identificatore Riga: valore HF sulla riga");
        	Hashtable hash = (Hashtable)e.nextElement();
        	for (Enumeration e1 = hash.keys(); e1.hasMoreElements();)
        	{
        		Object rowid = (Object) e1.nextElement(); 
        		Object valrow = (Object)hash.get(rowid);
        		out.println(rowid+": "+valrow);
        	}
        }
	}
	
	//stampa il risultato di un polling fatto su piu' target
	void outMultiPolls(Object[] targets,Vector polls, int op, String[] oids)
	{
		int j=0;
		for (Enumeration e = polls.elements(); e.hasMoreElements(); )
		{
			out.println("Results of polling on: "+targets[j++].toString());
			outPolls((Vector)e.nextElement(),op,oids);
			out.println();
		}
	}
			
			
				
	void snmpWalk(boolean soma, boolean conf, boolean mobility, Collection args)
	{
        String values[] = new String[Settings.NMAXOPTIONS];
        String host = null;
        PlaceID placeID = null;
        String[] oids = null;

        Iterator ParametersIterator = args.iterator();
        String param = (String)ParametersIterator.next();
        //se c'e' subito un'opzione e' sbagliato, e' obbligatorio specificare
		//il target
		if ( param.charAt(0) == '-')
        {
            out.println(usage);
            return;
        }
		//se si usa il naming di soma si avra' il nome di dominio ed il nome del place
		if (soma)
		{
			//recupero nome dominio
			String dominio = param;
			ParametersIterator.remove();
			//recupero nome place
			String place = (String)ParametersIterator.next();
			ParametersIterator.remove();
			placeID = new PlaceID(dominio,place);
			System.out.println("Dominio: "+dominio+" Place: "+place);
		}
		else
		{
			//recupero nome host
			host = param;
			ParametersIterator.remove();
			System.out.println("Host: "+host);
	    }

        //i parametri che rimangono nella Collection sono quelli corrispondenti alle variabili
        //static della classe Settings
        String[] rem = (String[])args.toArray(new String[0]);

        Settings sets = new Settings(debug,out);
        oids = sets.parseArguments(rem,options,values,usage);
        int port = 161;
        if (values[Settings.PORT] != null)
        	port = Integer.parseInt(values[Settings.PORT]);

        System.out.println("Port: "+port);
        for (int k=0; k<values.length; k++)
            System.out.println(options[k]+": "+values[k]);
        //fine parte uguale

        String startOID;
        if (oids == null)
            startOID = null;
        else
        {
     	   if (soma)
    		    if (config.getNumericOIDs(placeID,port,oids) == false)
    		    	return;
       	   else
   	    		if (config.getNumericOIDs(host,port,oids) == false)
   	    			return;

            startOID = oids[0];
        }

 		if (soma)
        	manager.snmpWalk(placeID,values,startOID,conf);
        else
        	manager.snmpWalk(host,values,startOID,conf);

        return;
   }

   public SnmpVar[][] snmpMGet(PlaceID[] places, int[] ports, String[] OIDs)
   {
   		byte op_type = SnmpAPI.GET_REQ_MSG;
   		SnmpVar[][] results = snmpMOp(op_type,places,ports,OIDs,null);

   		//stampo i risultati ottenuti appoggiandomi ad un metodo del StaticManager
		for (int j=0; j<results.length; j++)
		{
			String host = (env.placeNameService.getPlace(places[j])).host.getHostAddress();
			out.println(getID().toString()+": Answer from Snmp Agent on: ("+host+":"+ports[j]+")");
			config.outPDU(OIDs,results[j]);
			out.println();
		}

		out.println("FINE del TASK");
		return results;
   }

   //Metodo associato all'esecuzione di una GET su domini: per ogni dominio si attiva un sottomanager 
   //se non gia' presente sul place di default poi gli si comunica la richiesta
   //e' il sottomanager che si occupa di creare e inviare un agente mobile su tutti i suoi place
   public Hashtable snmpDGet(PlaceID[] domains, String[] OIDs)
   {   			
   		byte op_type = SnmpAPI.GET_REQ_MSG;

		Hashtable domag = new Hashtable();
   		for (int k=0; k<domains.length; k++)
   		{
   			AgentID dest = activateSubM(domains[k]);
   			//introduco l'associazione agentID-domainID nell'hashtable 
   		    //che poi utilizzero' per sapere da dove mi arrivano le risposte
   		    domag.put(dest,domains[k]);
   		

   			//recupero i place del dominio e le porte d'ascolto degli agenti su ogni place
   			PlaceID[] places = (PlaceID[])dom_places.get(domains[k]);
   			int[] ports = config.getAgentsPort(places);
   				
   			//preparo le informazioni da passare all'agente mobile
   			InfoAtomicSnmpOp info = prepareAtomicInfo(op_type,places,ports,OIDs,null);
			if (info == null)
				return null;
					
			//confeziono richiesta che dovro' poi inviare ad ogni subManager di dominio
			Request req = new Request("MobileMonitoring.SnmpAtomicOpMA",info);
			
   			//invia la richiesta al sottomanager
   			Message request = new Message(req,getID(),dest);
	   		env.agentManager.sendMessage(request);
   		}
		
		int nrecv = 0;
		//hashtable contenente le associazioni nome dominio-Vector di risultato
		Hashtable results = new Hashtable();
		//entro in un ciclo di attesa di messaggi di risposta pari al numero di domini
		while (nrecv != domains.length)
		{
			Message answer = mailbox.getMessage();
			nrecv++;
			Vector temp = new Vector();
			//recupero il nome del dominio da cui giunge la risposta
			PlaceID domain = (PlaceID)domag.get(answer.from);				
			boolean ok = false;
			//quello che ricevo o e' la risposta che mi aspetto o un messaggio di errore
			try { temp = (Vector)answer.message;}
			catch(ClassCastException  e) 
			{ 
				out.println("Error Message from subManager on "+domain+": "+(String)answer.message); 
				results.put(domain,null);
			}
			if (ok)
				results.put(domain,temp);
		}

   		//stampo i risultati ottenuti appoggiandomi ad un metodo dello StaticManager
   		int i=0;
		for (Enumeration enum = results.keys(); enum.hasMoreElements(); i++)
		{
			PlaceID dom = (PlaceID)enum.nextElement();
			out.println("Results from domain "+dom+" :");
			//recupero il risultato corrispondente
			Vector dris =  (Vector)results.get(dom);

			int j=0;
			for (Enumeration e=dris.elements(); e.hasMoreElements();j++)
			{
				//N.B. qui dovrei scrivere anche il nome del place appartenente al dominio che mi da' 
				//questo risultato
				out.println();
				SnmpVar[] oneplace = (SnmpVar[])e.nextElement();
				config.outPDU(OIDs,oneplace);
				out.println();
			}
		}

		out.println("FINE del TASK");
		return results;
   }
   
   /**se non c'e' gia' un sottomanager attivo sul default place del dominio lo attiva
   *  restituisce l'identificatore del sottomanager attivato o di quello gia' presente
   */
   private AgentID activateSubM(PlaceID domain)
   {
   		AgentID dest = null;
   		
		//se il subManager non e' attivo lo creo e invio passandogli l'identificatore dell'agente mobile corrente
   		//a cui dovra' restituire i risultati 
   		if (config.isDomainOn(domain) == false)
   		{
   			subInfo sub = new subInfo(getID(),domain);
   			String agentName = "MobileMonitoring.subManager";
			AgentWorker worker = env.agentManager.createAgent(agentName,sub,systemloader,true);
    		if( worker == null )
    		{	out.println( "ERROR: can't create subManager." ); return null; }
    		else
    		{
    			out.println(Header+" STARTING subManager "+agentName+" for "+domain);
    			try
    			{
      				worker.start();
    			}
       			catch( Exception e )
       			{
       				e.printStackTrace( out );
       			}
       			out.println( "Worker: " + worker + " CREATED AND STARTED." );
       			//setto a "on" lo stato del sottoManager di dominio
       			config.setDomainOn(domain);
       			//inizializzo l'identita' del sottomanager del dominio utile per successive richieste
       			config.setSubID(domain,worker.agent.getID());
    		}
   		}
   		else
   			//recupero l'identificatore del sottomanager gia' attivo
   			dest = config.getSubID(domain);
   		
   		return dest;
   }
   
   //disattiva tutti i sottomanager attivi inviando ad ognuno un messaggio di "STOP"
   //e togliendoli dalla configurazione
   private void deactivateSubM()
   {
   		Vector actives = config.getAllDomainOn();
   		if (actives == null)
   			return;
   		for (Enumeration e = actives.elements(); e.hasMoreElements();)
   		{
   			AgentID subM = 	(AgentID) e.nextElement();
   			
   			Request req = new Request("STOP", null);
			
   			//invia la richiesta al sottomanager
   			Message request = new Message(req,getID(),subM);
	   		env.agentManager.sendMessage(request);
	   		
	   		config.setDomainOff(subM.place);
	   	}
	   	return;
   } 

   public SnmpVar[][] snmpMGetNext(PlaceID[] places, int[] ports, String[] OIDs)
   {
   		byte op_type = SnmpAPI.GETNEXT_REQ_MSG;
   		SnmpVar[][] results = snmpMOp(op_type,places,ports,OIDs,null);

   		//stampo i risultati ottenuti appoggiandomi ad un metodo del StaticManager
		for (int j=0; j<results.length; j++)
		{
			String host = (env.placeNameService.getPlace(places[j])).host.getHostAddress();
			out.println(getID().toString()+": Answer from Snmp Agent on: ("+host+":"+ports[j]+")");
			config.outPDU(OIDs,results[j]);
			out.println();
		}

		out.println("FINE del TASK");
		return results;
   }

   public SnmpVar[][] snmpMGetBulk(PlaceID[] places, int[] ports, String[] OIDs, String nonrep, String maxrep)
   {
   		byte op_type = SnmpAPI.GETNEXT_REQ_MSG;
   		String[] extra = new String[2];
   		extra[0] = nonrep;
   		extra[1] = maxrep;

   		SnmpVar[][] results = snmpMOp(op_type,places,ports,OIDs,extra);

   		//stampo i risultati ottenuti appoggiandomi ad un metodo del StaticManager
		for (int j=0; j<results.length; j++)
		{
			String host = (env.placeNameService.getPlace(places[j])).host.getHostAddress();
			out.println(getID().toString()+": Answer from Snmp Agent on: ("+host+":"+ports[j]+")");
			config.outPDU(OIDs,results[j]);
			out.println();
		}

		out.println("FINE del TASK");
		return results;
   }

	Object[] snmpMHF(PlaceID[] places, int[] ports, String hf,boolean table)
	{
		String[] res = manager.parseHF(hf);
		if (res == null)
  			return null;

  		 hf = res[res.length-1];
  		 String oids[] = new String[res.length-1];
  		 for (int i=0; i<res.length-1; i++)
  		 	oids[i] = res[i];		
  		
  		InfoHF info = null;

  		InfoAtomicSnmpOp sub = prepareAtomicInfo(SnmpAPI.GET_REQ_MSG,places,ports,oids,null);

  		//se devo calcolare i valori di HF per ogni riga di una tabella avro' degli OID di tabella
  		//es. ifSpeed --> .1.3.6.1.2.1.2.2.1.5 , da cui l'identific. di riga --> .1.3.6.1.2.1.2.2.1.1
  		//e' il primo oggetto di una riga
  		if (table)
  		{
  			String row = oids[0].substring(0,oids[0].length()-1)+"1";
  			info = new InfoHF(sub,hf,row);
  		}
  		else
  			info = new InfoHF(sub,hf);
		
		if (info == null)
			return null;
		  		Crono.Start();
	
		//creo ed attivo l'agente mobile delegato opportuno
   		String agentName = "MobileMonitoring.HealthMA";
   		AgentWorker worker =
           env.agentManager.createAgent(agentName,info,systemloader,traceable);
    	if( worker == null )
        	out.println( "ERROR: can't create agent." );
    	else
    	{
    		out.println(Header+" STARTING DELEGATED AGENT "+agentName);
        	try
         	{
            	worker.start();
         	}
            catch( Exception e )
            {
            	e.printStackTrace( out );
            }
            out.println( "Worker: " + worker + " CREATED AND STARTED." );
    	}

   		out.println(Header+" MI BLOCCO IN ATTESA DEL MESSAGGIO DI RISPOSTA");
		//chiamata sospensiva, dovrebbe sbloccarsi solo quando arriva la risposta dall'agente delegato
		Message answer = mailbox.getMessage();
		Crono.Stop();
		System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
		out.println(Header+" MESSAGGIO RICEVUTO");
		//una volta ricevuto il messaggio di risposta puo' visualizzare tutte le informazioni
		//la risposta e' un vettore di Object nel caso semplice
		//un vettore di Hashtable nel caso di HF su tabella 
		Vector temp = (Vector)answer.message;
		
		Object[] ris = new Object[places.length];
		int j=0;
		if (table)
		{
			for (Enumeration e=temp.elements(); e.hasMoreElements();j++)
				ris[j] = (Hashtable)e.nextElement();
		}
		else
		{
			for (Enumeration e=temp.elements(); e.hasMoreElements();j++)
				ris[j] = e.nextElement();
		}
		return ris;

	}	
	
   SnmpVar[][] snmpMOp(byte op_type,PlaceID[] places, int[] ports, String[] OIDs, String[] extra)
   {	

   		//preparo le informazioni da passare all'agente mobile
   		InfoAtomicSnmpOp info = prepareAtomicInfo(op_type,places,ports,OIDs,extra);
		if (info == null)
			return null;   
					Crono.Start();	

   		//creo ed attivo l'agente mobile delegato opportuno
   		String agentName = "MobileMonitoring.SnmpAtomicOpMA";
   		AgentWorker worker =
           env.agentManager.createAgent(agentName,info,systemloader,traceable);
    	if( worker == null )
        	out.println( "ERROR: can't create agent." );
    	else
    	{
    		out.println(Header+" STARTING DELEGATED AGENT "+agentName);
        	try
         	{
            	worker.start();
         	}
            catch( Exception e )
            {
            	e.printStackTrace( out );
            }
            out.println( "Worker: " + worker + " CREATED AND STARTED." );
    	}

   		out.println(Header+" MI BLOCCO IN ATTESA DEL MESSAGGIO DI RISPOSTA");
		//chiamata sospensiva, dovrebbe sbloccarsi solo quando arriva la risposta dall'agente delegato
		Message answer = mailbox.getMessage();
		Crono.Stop();
		System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
		out.println(Header+" MESSAGGIO RICEVUTO");
		//una volta ricevuto il messaggio di risposta puo' visualizzare tutte le informazioni
		//la risposta e' un vettore di Snmpvar[] per ogni target
		//ogni elem. di temp e' un SnmpVar[]
		Vector temp = (Vector)answer.message;
		SnmpVar[][] ris = new SnmpVar[places.length][OIDs.length];
		int j=0;
		for (Enumeration e=temp.elements(); e.hasMoreElements();j++)
			ris[j] = (SnmpVar[])e.nextElement();
		return ris;

	}

	InfoDomain snmpMinMaxAve(PlaceID[] places,int[] ports, String OIDs[])
	{
	
   		//preparo le informazioni da passare all'agente mobile
   		InfoAtomicSnmpOp info = prepareAtomicInfo(SnmpAPI.GET_REQ_MSG,places,ports,OIDs,null);
		Crono.Start();

   		//creo ed attivo l'agente mobile delegato opportuno
   		String agentName = "MobileMonitoring.DomainInfoMA";
   		AgentWorker worker =
           env.agentManager.createAgent(agentName,info,systemloader,traceable);
    	if( worker == null )
        	out.println( "ERROR: can't create agent." );
    	else
    	{
    		out.println(Header+" STARTING DELEGATED AGENT "+agentName);
        	try
         	{
            	worker.start();
         	}
            catch( Exception e )
            {
            	e.printStackTrace( out );
            }
            out.println( "Worker: " + worker + " CREATED AND STARTED." );
    	}

   		//out.println(Header+" MI BLOCCO IN ATTESA DEL MESSAGGIO DI RISPOSTA");
		//chiamata sospensiva, dovrebbe sbloccarsi solo quando arriva la risposta dall'agente delegato
		Message answer = mailbox.getMessage();
		Crono.Stop();
		System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
		out.println(Header+" MESSAGGIO RICEVUTO");
		//una volta ricevuto il messaggio di risposta puo' visualizzare tutte le informazioni
		//la risposta e' un vettore di Snmpvar[] per ogni target
		InfoDomain ris = (InfoDomain)( ((Vector)answer.message).elementAt(0) );
		outInfoDomain(OIDs,ris);
		return ris;

	}
	
	
   /** costruisce una struttura contenente tutte le informazioni necessarie ad un MA
   *   per effettuare una richiesta Snmp elementare (Get/GetNext/GetBulk)
   */
   InfoAtomicSnmpOp prepareAtomicInfo(byte op, PlaceID[] places, int[] ports, String[] OIDs, String[] extra)
   {
   		int Ntargets = places.length;
   		int[] versions = new int[Ntargets];
   		String[] secnames = new String[Ntargets];
		String  filedeser = config.getUSMserFile();

		for (int i=0; i<Ntargets; i++)
   		{
   			PlaceID place = places[i];
   			PlaceInfo pinfo = env.placeNameService.getPlace(place);
   			String host = pinfo.host.getHostAddress();
   			int port = ports[i];
   			//recupero versione supportata
   			versions[i]  = config.getAgentVersion(host,port);
   			//recupero nome di sicurezza da utilizzare nelle interazione con l'agente
   			secnames[i] = config.getSecurityName(host,port);
   		}

   		//faccio le eventuali conversioni da formato simbolico a formato numerico
   		if (config.getNumericOIDs(OIDs) == false)
   			return null;

   		InfoAtomicSnmpOp infos = new InfoAtomicSnmpOp(getID(),places,ports,versions,secnames,filedeser,OIDs,op,extra,debug);
   		return infos;
   	}

   snmpTable[] getMTable(PlaceID[] places, int[] ports, String tabOID)
	{
		//preparo le informazioni da passare all'agente mobile
   		InfoTable info = prepareTableInfo(places,ports,tabOID);
   		if (info == null)
   			return  null;
		Crono.Start();

   		//creo ed attivo l'agente mobile delegato opportuno
   		String agentName = "MobileMonitoring.SnmpTableMA";
   		AgentWorker worker =
           env.agentManager.createAgent(agentName,info,systemloader,traceable);
    	if( worker == null )
        	out.println( "ERROR: can't create agent." );
    	else
    	{
    		out.println(Header+" STARTING DELEGATED AGENT "+agentName);
        	try
         	{
            	worker.start();
         	}
            catch( Exception e )
            {
            	e.printStackTrace( out );
            }
            out.println( "Worker: " + worker + " CREATED AND STARTED." );
    	}

   		out.println(Header+" MI BLOCCO IN ATTESA DEL MESSAGGIO DI RISPOSTA");
		//chiamata sospensiva, dovrebbe sbloccarsi solo quando arriva la risposta dall'agente delegato
		Message answer = mailbox.getMessage();
		Crono.Stop();
		System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
		out.println(Header+" MESSAGGIO RICEVUTO");
		out.println();

		//recupero la risposta e ne stampo il contenuto
		Vector temp = (Vector)answer.message;
		snmpTable ris[] = new snmpTable[places.length];

		int j=0;
		for (Enumeration e=temp.elements(); e.hasMoreElements();j++)
			ris[j] = (snmpTable)e.nextElement();

		for (int i=0; i<ris.length; i++)
		{
			String host = (env.placeNameService.getPlace(places[i])).host.getHostAddress();
			out.println("Table retrieved from Agent Snmp on: ("+host+":"+ports[i]+")");
			ris[i].setOut(out);
			config.printTable(new sharedOut(out),ris[i]);
			out.println();
		}

		out.println("FINE del TASK");
		return ris;

	}

   /** costruisce una struttura contenente tutte le informazioni necessarie ad un MA
      * per effettuare una richiesta tabellare
    */
   	InfoTable prepareTableInfo(PlaceID[] places, int[] ports, String tabOID)
   	{
   		int Ntargets = places.length;
   		int[] versions = new int[Ntargets];
   		String[] secnames = new String[Ntargets];

		String  filedeser = config.getUSMserFile();

   		for (int i=0; i<Ntargets; i++)
   		{
   			PlaceID place = places[i];
   			PlaceInfo pinfo = env.placeNameService.getPlace(place);
   			String host = pinfo.host.getHostAddress();
   			int port = ports[i];
   			//recupero versione
   			versions[i] = config.getAgentVersion(host,port);
   			//recupero nome di sicurezza da utilizzare nelle interazione con l'agente
   			secnames[i] = config.getSecurityName(host,port);
   		}

   		//eventuale conversione da simbolico a numerico
   		//N.B. mi appoggio ai moduli MIB gia' caricati => assicurarsi che una richiesta avvenga dopo che
   		//sono stati caricati i moduli MIB opportuni(ad es. tramite una specie di attivazione del monitoraggio)
   		String[] oids = new String[1];
   		oids[0] = tabOID;
   		if (config.getNumericOIDs(oids) == false)
   			return null;
   		tabOID = oids[0];

   		//recupero gli OID delle colonne appartenenti alla tabella
   		String[] columns = config.getColTable(tabOID);
   		//rimuovo prefisso comune da OID colonne
   		for (int j=0; j<columns.length;j++)
   			columns[j] = columns[j].substring(tabOID.length()+1);

   		InfoTable info = new InfoTable(getID(),places,ports,versions,secnames,filedeser,tabOID,columns,debug);
   		return info;
   	}

    snmpTable[] getMFiltering(PlaceID[] places, int[] ports, String tabOID, String condition)
	{
        //preparo le informazioni da passare all'agente mobile
     	InfoFiltering info = prepareFiltering(places,ports,tabOID,condition);
     	if (info == null)
    		return null;
     	String agentName = "MobileMonitoring.SnmpFilterTableMA";
	    Crono.Start();
	    //creo ed attivo l'agente mobile delegato opportuno
	    AgentWorker worker =
           env.agentManager.createAgent(agentName,info,systemloader,traceable);
    	if( worker == null )
    	{
        	out.println( "ERROR: can't create agent." );
        	return null;
        }
    	else
   	    {
	        out.println(Header+" STARTING DELEGATED AGENT "+agentName);
            try
            {
              	worker.start();
            }
            catch( Exception e )
            {
            	e.printStackTrace( out );
            }
            out.println( "Worker: " + worker + " CREATED AND STARTED." );
        }
        out.println(Header+" MI BLOCCO IN ATTESA DEL MESSAGGIO DI RISPOSTA");
	    //chiamata sospensiva, dovrebbe sbloccarsi solo quando arriva la risposta dall'agente delegato
        Message answer = mailbox.getMessage();
        Crono.Stop();
		System.out.println("Tempo richiesto per l'esecuzione del task: "+Crono.toString());
		out.println(Header+" MESSAGGIO RICEVUTO");
		out.println();
 //recupero la risposta e ne stampo il contenuto

		Vector temp = (Vector)answer.message;
		snmpTable[] ris = new snmpTable[places.length];

		int j=0;
		for (Enumeration e=temp.elements(); e.hasMoreElements();j++)
			ris[j] = (snmpTable)e.nextElement();
		for (int i=0; i<ris.length; i++)
		{
			String host;
			host = (env.placeNameService.getPlace(places[i])).host.getHostAddress();
			out.println("Table retrieved from Agent Snmp on: ("+host+":"+ports[i]+")");
			out.println("has "+ris[i].getNRows()+" row(s) matching condition");
			ris[i].setOut(out);
			config.printTable(new sharedOut(out),ris[i]);
			out.println();
		}
		out.println("FINE del TASK");
		return ris;
    }

    /** costruisce una struttura contenente tutte le informazioni necessarie ad un MA
      * per effettuare il filtraggio di una tabella reperita tramite richiesta Snmp
    */
    InfoFiltering prepareFiltering(PlaceID[] places, int[] ports, String tabOID, String condition)
 	{
 		int Ntargets = places.length;
   		int[] versions = new int[Ntargets];
   		String[] secnames = new String[Ntargets];

		String  filedeser = config.getUSMserFile();

   		for (int i=0; i<Ntargets; i++)
   		{
   			PlaceID place = places[i];
   			PlaceInfo pinfo = env.placeNameService.getPlace(place);
   			String host = pinfo.host.getHostAddress();
   			int port = ports[i];
   			//recupero versione supportata
   			versions[i] = config.getAgentVersion(host,port);
   			//recupero nome di sicurezza da utilizzare nelle interazione con l'agente
   			secnames[i] = config.getSecurityName(host,port);
   		}

   		//eventuale conversione da simbolico a numerico
   		//N.B. mi appoggio ai moduli MIB gia' caricati => assicurarsi che una richiesta avvenga dopo che
   		//sono stati caricati i moduli MIB opportuni(ad es. tramite una specie di attivazione del monitoraggio)
   		String[] oids = new String[1];
   		oids[0] = tabOID;
   		if (config.getNumericOIDs(oids) == false)
   			return null;
   		tabOID = oids[0];

   		//recupero gli OID delle colonne appartenenti alla tabella
   		String[] columns = config.getColTable(tabOID);
   		//elimino prefisso comune da OID colonne
   		for (int j=0; j<columns.length;j++)
   			columns[j] = columns[j].substring(tabOID.length()+1);

   		InfoFiltering info = new InfoFiltering(getID(),places,ports,versions,secnames,filedeser,tabOID,columns,condition,debug);
   		return info;
   	}

   	public boolean[] distributeConfiguration()
   	{
   		InfoConfiguration info = prepareConfigurationInfo();
		
		if (info == null)
			return null;
			
   		//creo ed attivo l'agente mobile delegato opportuno
   		String agentName = "MobileMonitoring.ConfigurationV3MA";
   		AgentWorker worker =
           env.agentManager.createAgent(agentName,info,systemloader,traceable);
    	if( worker == null )
        	out.println( "ERROR: can't create agent." );
    	else
    	{
    		out.println(Header+" STARTING DELEGATED AGENT "+agentName);
        	try
         	{
            	worker.start();
         	}
            catch( Exception e )
            {
            	e.printStackTrace( out );
            }
            out.println( "Worker: " + worker + " CREATED AND STARTED." );
    	}

   		out.println(Header+" MI BLOCCO IN ATTESA DEL MESSAGGIO DI RISPOSTA");
		//chiamata sospensiva, dovrebbe sbloccarsi solo quando arriva la risposta dall'agente delegato
		Message answer = mailbox.getMessage();
		out.println(Header+" MESSAGGIO RICEVUTO");
		out.println();

		PlaceID[] places = info.getDestinations();
		int[] ports = info.getPorts();

		boolean[] result_code = (boolean[])answer.message;

		for (int i=0; i<result_code.length; i++)
		{
			String host = (env.placeNameService.getPlace(places[i])).host.getHostAddress();
			if (result_code[i])
				out.println("Configuration stored on: ("+host+":"+ports[i]+") successfully");
			else
				out.println("Problems in storing configuration on: ("+host+":"+ports[i]+")");
		}

		return result_code;
	}
	
	/** metodo per il recupero dei place costituenti ogni dominio noto
	*/
	private Hashtable discoverPlaces()
	{
		//recupero tutti i domini noti
		PlaceID[] domains = env.domainNameService.getDomainsArray();
		//preparo le informazioni da passare all'agente mobile
        BasicTour info = new BasicTour(getID(),domains,debug);
   		if (info == null)
   			return  null;

   		//creo ed attivo l'agente mobile delegato opportuno
   		String agentName = "MobileMonitoring.findPlacesMA";
   		AgentWorker worker =
           env.agentManager.createAgent(agentName,info,systemloader,traceable);
    	if( worker == null )
        	out.println( "ERROR: can't create agent." );
    	else
    	{
    		out.println(Header+" STARTING DELEGATED AGENT "+agentName);
        	try
         	{
            	worker.start();
         	}
            catch( Exception e )
            {
            	e.printStackTrace( out );
            }
            out.println( "Worker: " + worker + " CREATED AND STARTED." );
    	}

   		out.println(Header+" MI BLOCCO IN ATTESA DEL MESSAGGIO DI RISPOSTA");
		//chiamata sospensiva, dovrebbe sbloccarsi solo quando arriva la risposta dall'agente delegato
		Message answer = mailbox.getMessage();
		out.println(Header+" MESSAGGIO RICEVUTO");
		out.println();
		
		Vector result = (Vector)answer.message;
		
		//creo l'hastable dominio ---> place del dominio
		Hashtable association = new Hashtable();
		int k=0;
		for (Enumeration e=result.elements(); e.hasMoreElements();k++)
			association.put(domains[k],(PlaceID[])e.nextElement());
		
		return association;
	}
			 



    /** costruisce una struttura contenente tutte le informazioni necessarie ad un MA
      * che deve propagare le informazioni di configurazione sui dispositivi conteneti gli agenti Snmp noti
    */
  	InfoConfiguration prepareConfigurationInfo()
   	{
   		config.restoreConfiguration();
   		PlaceID cur = env.placeID;
   		InetAddress curaddr = env.placeNameService.getPlace(cur).host;
   try{System.out.println(InetAddress.getLocalHost());}
   catch(java.net.UnknownHostException e) {}
   		//recupero gli utenti presenti nella configurazione corrente
   		Enumeration users = config.getConfiguredUsers();

		if (users.hasMoreElements() == false)
			return null;
			
		//devo usare dei Vector perche' a priori non so quanti saranno i place coinvolti
		Vector places = new Vector();
		Vector ports = new Vector();
   		String filedeser = config.getUSMserFile();
System.out.println(filedeser);
   		Vector infous = new Vector();

   		//qui per ogni utente recupero place:porta di riferimento e costruisco infoUser corrispondente
   		for(; users.hasMoreElements();)
   		{
   			USMUserEntry user = (USMUserEntry)users.nextElement();
  			SnmpEngineEntry snmpentry = user.getEngineEntry();
if (user == null)  
   System.out.println("Problemi 1");
else if (snmpentry == null)
   System.out.println("Problemi 2");
   
   			String host = snmpentry.getRemoteHost();
   			int port = snmpentry.getRemotePort();
   System.out.println(host+" "+port);
   			PlaceID place = config.getAgentPlace(host,port); 
   			InetAddress placeaddr = env.placeNameService.getPlace(place).host;
   			//se esiste un place su quell'host e 
   			//se il place non si trova sulla stessa macchina di quello corrente lo aggiungo all'itinerario
   			if ((env.placeNameService.getPlace(place) != null) && (placeaddr.equals(curaddr) == false))
   			{
	   			places.add(place);
	   			ports.add(new Integer(port));   	
	System.out.println(place);
	   			infous.add(new infoUser(user));
	   		}
   		}
		
		if (places.size() == 0)
			return null;
			
		int[] porte = new int[ports.size()];
		int k =0; 
		for (Enumeration e = ports.elements(); e.hasMoreElements();k++)
		{
			Integer p = (Integer)e.nextElement();
			porte[k] = p.intValue();
		}
		
		infoUser[] infos = (infoUser[])infous.toArray(new infoUser[0]);
		PlaceID[] ps = (PlaceID[]) infous.toArray(new PlaceID[0]);	
   		InfoConfiguration info = new InfoConfiguration(getID(),ps,porte,new File(filedeser),infos,debug);
   		return info;
   	}

  /** Converte una stringa contenente una sequenza di parametri
  * in una Collection di singoli parametri.
  */
  public Collection StringToParameters( String ParametersLine )
  {
    final String TokenDelimiters = " ";       // Elenco separatori di items: scartati nella lettura
    Collection Parameters = new Vector();

    StringTokenizer stok = new StringTokenizer( ParametersLine, TokenDelimiters , true );

    try
    {
      while( stok.hasMoreTokens() )
      {
        String Token = stok.nextToken();

        if( TokenDelimiters.indexOf( Token ) == -1 )  // Scarto gli spazi
          Parameters.add( Token );
      }
    }
    catch( NoSuchElementException  e )
    {}   // Nessun problema: semplicemente  finita la stringa!

    //System.out.println( "Parameters: " + Parameters );
    return Parameters;
  }

	void outInfoDomain(String[] oids,InfoDomain info)
	{
		for (int j=0; j<oids.length; j++)
		{
			out.println(oids[j]);
			info.show(out,j);
		}
    }


}
