package StaticMonitoring;

import com.adventnet.snmp.snmp2.*;
import java.io.PrintStream;

class ReceiverAtomicReq extends MonitorConfig.Debug implements SnmpClient,Operations
{
	//variabile che indica se il lavoro e' concluso
	boolean done;
	//variabile che indica se il lavoro si e' concluso senza errori
	boolean noerr;
	//identificatore della richiesta di cui ottengo risposta
	int reqID;
	//variabile destinata a contenere i risultati
	SnmpPDU result;

	protected ReceiverAtomicReq(boolean deb,PrintStream o)
	{
		super(deb,o);
		done = false;
		noerr = false;
		result = null;
	}

	public boolean callback(SnmpSession sess, SnmpPDU pdu, int requestID)
	{
		reqID = requestID;
		if (check(pdu))
		{
			result = pdu;
			noerr = true;
		}
		done = true;
		System.out.println("DONE: "+reqID);
		return noerr;
	}

	public boolean authenticate(SnmpPDU pdu,String community)
	{
		return true;
	}

	public void debugPrint(String debugOutput)
	{
	}

	boolean check(SnmpPDU pdu)
    {
        //verifico se la pdu e' nulla (time out)
        if (pdu == null)
        {
            trace_err("NULL PDU in response");
            return false;
        }

        //verifico se la pdu contiene errori
        if (pdu.getErrstat() > 0)
        {
            trace_err("Error occurred in PDU "+pdu.getError());
            pdu.fix();
            return false;
        }

	    return true;
    }

    public boolean hasDone()
    {
    	return done;
    }

    SnmpPDU getAnswer()
    {
    	return result;
    }
}




